
'use strict';
//========================================================================================================================================

function commDownloadSequences() {

    uxProgressBarEvent();

    //First save a backup of the current state, as the download will over write it
    stateUX.targetSaveFile = "./saves/downloaded-backup.auroraseq"
    fs.writeFile(stateUX.targetSaveFile, JSON.stringify('hold'), async function (err) {
        if (err) {
            return console.log(err);
        }
        await systemSaveSequenceFile();
    });


    auroraCMD.requestFullDownload(function (buf) {
        //'payload reception' callback
        console.log("received bytes ", buf); //DEBUG
        let seqIndex;
        let convertedIndexes = [];


        switch (stateDevice.soft.indexMemoryModel) {
            case 0: //16-bit, standard 

                break;
            case 1: //16-bit, fillUpper
                seqIndex = buf.splice(0, 768); //1024 is index size with phantom padding = 256 entries
                for (let i = 0; i < seqIndex.length; i += 3) {
                    let i0 = seqIndex[i]; //LSB
                    let i1 = seqIndex[i + 1]; //MSB
                    let i2 = seqIndex[i + 2]; //ignore
                    console.log(i0, i1, i2);
                    let merged = (i1 << 8) | (i0);
                    if (i == 0) convertedIndexes.push(merged)
                    else if (merged > 0) convertedIndexes.push(merged)
                }
                break;
            case 2: //32-bit, standard - external flash
                seqIndex = buf.splice(0, 1024); //1024 is index size with phantom padding = 256 entries
                for (let i = 0; i < seqIndex.length; i += 4) {
                    let i3 = seqIndex[i];
                    let i2 = seqIndex[i + 1];
                    let i1 = seqIndex[i + 2];
                    let i0 = seqIndex[i + 3];
                    let merged = (i0 << 24) | (i1 << 16) | (i2 << 8) | (i3)
                    if (i == 0) convertedIndexes.push(merged)
                    else if (merged > 0) convertedIndexes.push(merged)
                }
                break;
            case 3: //32-bit, fillUpper
                //no longer used - was 32-bit internal memory with fillupper
                break;
        } //end switch



        console.log(convertedIndexes);


        mainObj.userIndex = []; //does not rebuild the index
        let newSequences = [];
        // for (const i in convertedIndexes) {
        for (let i = 0; i < convertedIndexes.length - 1; i++) {
            // newSequences.push(JSON.parse(JSON.stringify(seqTemplate)));
            let newSeq = JSON.parse(JSON.stringify(seqTemplate));
            let seqDataLen = convertedIndexes[i + 1] - convertedIndexes[i];
            let seqData = buf.splice(0, seqDataLen);

            // console.log(seqDataLen);
            // console.log("dataFrameLen:", ((seqData[11] << 8) | seqData[12]), "frameAmt:", ((seqData[5] << 8) | seqData[6]), "Mode:", sequenceConvertMode(seqData[4]));
            newSeq.name = "Read Sequence #" + (i + 1);
            newSeq.description = "Downloaded from " + stateDevice.soft.name;
            newSeq.memory = seqDataLen;
            newSeq.mode = convertSeqModeV2(seqData[4]);
            newSeq.frames = ((seqData[5] << 8) | seqData[6]);
            newSeq.speed = ((seqData[9] << 8) | seqData[10]);
            newSeq.transition = convertTransitionFlags(0b00000111 & (seqData[13] >> 5));
            newSeq.playMode = convertPlayMode(0b00000111 & (seqData[13] >> 2));
            newSeq.colorMode = convertColorMode((0b00000011 & seqData[13]));
            newSeq.povGridSpeed = seqData[14];
            newSeq.packetClone = seqData[15];
            let chanSz = ((seqData[11] << 8) | seqData[12]);
            newSeq.numPixels = chanSz / getColorModeMult(newSeq.colorMode);
            newSeq.frames++; //adjust from base 0 to base 1
            console.log(newSeq);
            console.log(seqData);
            seqData.splice(0, 16); //remove header data


            ///header - startVals - DataFrameVar - DataFrames
            if (newSeq.mode == "mFade" || newSeq.mode == "mGradient") {
                newSeq.startVals = Uint8Array.from(seqData.splice(0, chanSz));
                newSeq.frameVar = Uint8Array.from(seqData.splice(0, chanSz));
                if (newSeq.mode == "mFade") {
                    for (let q = 0; q < newSeq.frames; q++) newSeq.dataFrames.push(Uint8Array.from(seqData.splice(0, chanSz)));
                }
                else if (newSeq.mode == "mGradient") {
                    for (let q = 0; q < newSeq.frames; q++) newSeq.dataFrames.push(Uint8Array.from(seqData.splice(0, 4)));
                }
            }
            else if (newSeq.mode == "mInstant") {
                newSeq.startVals = Uint8Array.from(seqData.splice(0, chanSz));
                newSeq.frameVar = seqData.splice(0, chanSz);
                seqData.splice(0, (newSeq.frames * 2)); //REMOVE DUMMY SLIDE FLAGS
                for (let q = 0; q < newSeq.frames; q++) newSeq.dataFrames.push(Uint8Array.from(seqData.splice(0, chanSz)));
            }
            else if (newSeq.mode == "mFile") {
                for (let q = 0; q < newSeq.frames; q++) newSeq.dataFrames.push(Uint8Array.from(seqData.splice(0, chanSz)));
            }
            else if (newSeq.mode == "mPOV") {
                for (let q = 0; q < newSeq.frames; q++) newSeq.dataFrames.push(Uint8Array.from(seqData.splice(0, chanSz))); 3
                newSeq.packetclone = 0
                // newSeq.povGridSpeed = 0;
                newSeq.povFramesAmt = 0; //not sure what this is yet, will dig into it when I do POVs
                newSeq.povVideoMode = 0;
            }
            else if (newSeq.mode == "mList") {
                newSeq.listID = [];
                newSeq.listIteration = [];
                newSeq.listFlags = [];

                newSeq.listID = (seqData.splice(0, newSeq.frames));

                newSeq.listFlags = (seqData.splice(0, newSeq.frames));
                let iterations = (seqData.splice(0, newSeq.frames * 2));
                for (let q = 0; q < iterations.length; q += 2) {
                    newSeq.listIteration.push(((iterations[q + 1] << 8) | iterations[q]));
                }
            }
            // console.log(seqData);
            // console.log(buf);
            newSequences.push(newSeq);

            mainObj.userIndex.push(i);
        } //end for();
        mainObj.seq = newSequences;

        // mainObj.userIndex = []; //does not rebuild the index
        stateUX.targetSaveFile = "./saves/downloaded-generated.auroraseq"
        fs.writeFile(stateUX.targetSaveFile, JSON.stringify('hold'), async function (err) {
            if (err) {
                return console.log(err);
            }
            await systemSaveSequenceFile();
            systemLoadSequenceFileInit(stateUX.targetSaveFile, false);
            refreshTab();
        });


        // console.log(newSequences);
    });

}

//========================================================================================================================================

function commGetDeviceSerialNumber() {
    console.log("commGetDeviceSerialNumber()");
    // if (stateCommunication.connected == false)  return;

    auroraCMD.requestSerialNumber(function (buf) {
        //'payload reception' callback
        let str = buf.map(v => decToHex(v).toUpperCase());
        // console.log("serial Number:", str); //DEBUG
        stateDevice.hard.serialNum = str.join("");
        uxTabHardwareUpdate();
    });
}

//========================================================================================================================================

function commDownloadConfigs() {
    console.log("commDownloadConfigs()");
    if (stateCommunication.connected == false) {
        pushMessageToLog("No NLED device is connected, can not download Device Configurations.");
        return;
    }

    auroraCMD.requestConfigDownload(stateDevice.soft.configBytes, function (buf) {
        //'payload reception' callback
        console.log("received all config bytes ", stateDevice.soft.configBytes.length, buf); //DEBUG
        commApplyDeviceConfigValues(buf);
        pushMessageToLog("The connected device has responded with it's Device Configuration Settings.");
    });
}

//========================================================================================================================================

function commUploadConfigs() {
    console.log("commUploadConfigs()");

    if (stateCommunication.connected == false) {
        pushMessageToLog("No NLED device is connected, can not upload Device Configurations.");
        return;
    }

    let json = JSON.parse(fs.readFileSync(path.join(process.cwd(), 'assets/json/config-modules.json'), 'utf8'));
    let bConfigurations = 0; // primary configuration flags
    let configByteArray = [];
    configByteArray.length = stateDevice.soft.configBytes.length;
    let moduleCompleted = [];

    //---------------------------- Scan the bits and build the config byte(s) ---------------------------------------------------

    stateDevice.soft.configFlags.forEach(function (val, index) {
        for (var key in json) {
            if (json.hasOwnProperty(key)) {
                if (json[key].bitStr.includes(val)) {//} && !moduleCompleted.includes(key)) {
                    //the module scanned does have the matching config bit
                    //console.log("Bit " + index + "   " + key + "  " + val + "   " + json[key].bitStr.length);

                    //let num = moduleCompleted.filter(x => x == key).length; //= number of times the module is on the list. Which indicates the bit order
                    let num = json[key].bitStr.indexOf(val); // DID THIS FIX IT????????????? really think so

                    let result = commGetDeviceConfigVal(key, 'bit');
                    //console.log("result is 0b" + getValue8BitBinary(result)); //debug

                    let mask = (1 << num); //make the bit mask
                    if ((result & mask) != 0) bConfigurations |= (1 << (index)); //apply bit mask and check if se

                    moduleCompleted.push(key); //list to track modules that have been parsed
                }
            } //end if()
        } //end for()
    });

    console.log("bConfigurations: " + getValue16BitMSB(bConfigurations).toString(2) + " " + getValue16BitLSB(bConfigurations).toString(2) + "  " + getValue16BitBinary(bConfigurations))

    //---------------------------- Place config bits into slot ---------------------------------------------------

    //Place in their proper array elements, in order
    configByteArray[helperByte("bConfigurationsMSB")] = getValue16BitMSB(bConfigurations); //place the correct 8-bit block into the transmission array
    configByteArray[helperByte("bConfigurationsLSB")] = getValue16BitLSB(bConfigurations);

    //---------------------------- Now Parse and Collect Bytes ---------------------------------------------------

    moduleCompleted = []; //clear parsed list
    stateDevice.soft.configBytes.forEach(function (val, index) {
        for (var key in json) {
            if (json.hasOwnProperty(key)) {
                //console.log(json[key].byteStr, json[key].byteStr.includes(val));
                if (json[key].byteStr.includes(val)) {//} && !moduleCompleted.includes(key)) {
                    //the module scanned does have the matching config byte
                    //console.log("Byte " + index + "   " + key + "  " + val + "  " + json[key].byteStr);

                    //let num = moduleCompleted.filter(x => x == key).length; //= number of times the module is on the list. Which indicates the byte order
                    let num = json[key].byteStr.indexOf(val); // DID THIS FIX IT????????????? really think so

                    //console.log("RAN", key, 'byte', num); //DEBUG

                    configByteArray[helperByte(val)] = commGetDeviceConfigVal(key, 'byte', num); //i can only be 0 or 1, for MSB or LSB. So far would need an update.s
                    moduleCompleted.push(key); //list to track modules that have been parsed
                }
            } //end if()
        } //end for()
    });

    //-------------------------------------------------------------------------------

    //console.log(configByteArray);
    let configTxArray = Uint8Array.from(configByteArray); //could check all are 0 - 255 or throw error
    console.log(configTxArray);  //finalized array

    uxProgressBarFake(0, 5, 50); //start 0, end 5, 50mS
    //no need to support normal progress event

    auroraCMD.requestConfigUpload(configTxArray, function () {
        //'command confirmation' callback
        console.log("configTxArray[]: ", configTxArray); //DEBUG
        pushMessageToLog("The Configuration Settings have been sucessfully uploaded to the device.");
    });

    //-------------------------------------------------------------------------------

    function helperByte(str) {
        return stateDevice.soft.configBytes.findIndex(element => element.includes(str));
    }

    //-------------------------------------------------------------------------------
}

//========================================================================================================================================

function commFullSeqUpload() {
    console.log("commFullSeqUpload()");
    //DMX/serial icons? no longer... but leave it in there... technically they are sequences

    if (stateCommunication.connected == false) {
console.log("FALSESESESESE",stateDevice.soft.indexMemoryModel);
        if (stateDevice.soft.indexMemoryModel == 99) {
            //no USB/serial, instead render out and save to file
            let myPromise = new Promise(function (myResolve, myReject) {
                // "Producing Code" (May take some time)
                // sequenceRenderInit(mainObj.seq[0]);
                sequenceSelect(mainObj.userIndex[0]);
                sequenceRenderInit(mainObj.seq[mainObj.userIndex[0]]);
                myResolve(); // when successful
            });

            myPromise.then(
                function (value) { /* code if successful */
                    let options = {
                        title: "Save Sequence To Storage Media",
                        filters: [
                            { name: 'Binary File', extensions: ['bin'] }
                        ],
                        buttonLabel: "Save File",
                        properties: ['saveFile'],
                        defaultPath: mainObj.seq[mainObj.userIndex[0]].name.replace(/[<>:"\/\\|?*]#+/g, '').replace(" ", "")
                    }

                    dialog.showSaveDialog(options).then(prom => {
                        commonFileDialogClose(prom.filePath, prom.canceled);
                        try {
                            if (!prom.canceled) {
                                fs.writeFile(prom.filePath.toString(), new Uint8Array(seqWriteToFileBuf), (err) => {
                                    if (err) console.log(err);
                                    else console.log("file write complete", seqWriteToFileBuf.length);
                                });
                            }
                        }
                        catch (e) {
                            console.log('Error:', e.stack);
                        }
                    });
                },
                function (error) { /* code if some error */ }
            );
            return;
        }
        pushMessageToLog("No NLED device is connected, can not upload the color sequences and index.");
        return;
    }

    if (mainObj.indexedMemory > stateDevice.soft.dataSize) {
        pushMessageToLog("Device does not have enough memory to upload the Indexed sequences.");
        return;
    }
    //-------------------------- Ensure all mLists are valid ---------------------------

    let errFlag = -1;

    mainObj.seq.forEach(function (val, index) {
        if (val.mode == 'mList') {
            val.listID.forEach(function (v, i) {
                //console.log("chekcing " + index + "  " + v);
                if (v == null) {
                    pushMessageToLog("The linked sequence '" + mainObj.seq[index].name + "' contains a sequence that has been deleted. Please review before uploading.");
                    mainObj.seq[index].errorFlag = true;
                    errFlag = index;
                    // return; //doesn't work out of forEach
                }
            });
        }
    });

    if (errFlag > -1) {
        uxTriggerElementClick('navtab-timeline')
        sequenceSelect(errFlag);
        return;
    }

    //-------------------------- Sequence IDs are valid, data may not be ---------------------------

    sequenceMeasureAll(); //couldn't hurt to run it again, probably already correct

    let memCount = 0;
    let indexListArr = [];
    let txIndexArray = [];
    let memoryAdr = [];  //debug
    //IndexMemoryModel 0: standard 16-bit 	
    //IndexMemoryModel 1: standard 32-bit 		

    let trackObj = [];
    let vID = 0;

    //------------------------ User Index has been mapped,  Map extended index ------------------

    indexListArr.push(...mainObj.userIndex); //put user index on sequence ListArray

    //Check if idle sequence ID is on the ListArray yet, if not add it. - Has to be before mList ones for whatever reason....
    if (!indexListArr.includes(mainObj.idleSeqID)) indexListArr.push(mainObj.idleSeqID);

    //put all sequences that are referenced from a mList and not already found to the ListArray
    mainObj.seq.forEach(function (val, id) {
        if (val.mode == 'mList' && mainObj.userIndex.includes(id)) {
            //console.log("List squence also included on index at ID #", id);
            //Now iterate through .listIDs
            mainObj.seq[id].listID.forEach(function (v, i) {
                //console.log("List ID on", val.listID[i]);
                indexListArr.push(val.listID[i]);
            });
        }
    });

    console.log(indexListArr);
    //Scan ListArray, and assign virtual IDs.
    indexListArr.forEach(function (v, i) {
        if (!mainObj.seq[v].hasOwnProperty('linker')) {
            //console.log(mainObj.seq[v].name);
            mainObj.seq[v].linker = {
                virtualID: vID,
                internalID: indexListArr[i],
                name: mainObj.seq[v].name,
                mapAdr: memCount,
            }
            memoryAdr.push(memCount); //debug
            helperIndexPacker(memCount);
            memCount += mainObj.seq[v].memory;
            trackObj.push(mainObj.seq[v].linker);
            vID++; //track it
        }
        else {
            //console.log("already found: " + mainObj.seq[v].name, vID, i, mainObj.userIndex.length);
            if (i >= mainObj.userIndex.length) {
                //it is on the extended index

            }
            else {
                //it is on the userIndex, so.....
                memoryAdr.push(mainObj.seq[v].linker.mapAdr); //debug
                helperIndexPacker(mainObj.seq[v].linker.mapAdr); //place the same address into index
                vID++;
            }
        }
    });

    console.log(indexListArr);

    //Find any indexed mList sequences, and give them a linker listID based on the virtual IDs.
    mainObj.seq.forEach(function (seq, id) {
        if (seq.mode == 'mList' && mainObj.userIndex.includes(id)) {
            //console.log("List squence also included on index at ID #", id);
            //this list sequence is on the index, remap the IDs
            mainObj.seq[id].linker.listID = []; //create new
            mainObj.seq[id].listID.forEach(function (v, i) {
                let inter = mainObj.seq[id].listID[i]; //internal software ID
                let mapped = mainObj.seq[inter].linker.virtualID;
                mainObj.seq[id].linker.listID.push(mapped);
            });
        }
    });

    console.log(trackObj);
    console.log(memoryAdr);

    //add a unused index entry that will store the value of total memory used - excluding index space
    let indexedTotalSize = trackObj[trackObj.length - 1].mapAdr + mainObj.seq[indexListArr[indexListArr.length - 1]].memory;
    vID++;

    console.log(indexedTotalSize);
    helperIndexPacker(indexedTotalSize);
    //------------------------ Pad the rest of the packet with 0s ------------------

    for (let i = vID; i < stateDevice.soft.maxIndexed; i++) helperIndexPacker(0);

    //------------------------------------------------------------------------------

    //console.log(txIndexArray);

    //------------------------------------------------------------------------------

    // let txArray = Array.from(txIndexArray); //start with the index addresses
    let txSeqArray = []; //start with the index addresses
    for (let i = 0; i < trackObj.length; i++) {

        commPackSequence(mainObj.seq[trackObj[i].internalID], 'full', txSeqArray);

        //txSeqArray.push(...commPackSequence(mainObj.seq[trackObj[i].internalID], 'full')); //now add the sequence data

        console.log("=================  txSeqArray len:", txSeqArray.length)
        // for (let x = 0, len = tempArr.length; x < len; x++) {
        //     txSeqArray.push(tempArr[x]);
        // }


    }

    //------------------------------ Calc Index Packet Size ------------------------------------------------

    let packetSzIndex = stateDevice.soft.packetsSize.indexBlock;
    let packetAmtIndex = 0;

    if ((txIndexArray.length % packetSzIndex) > 0) {
        console.log(txIndexArray)
        console.error("INDEX PACKET TOO SMALL, ERROR!", txIndexArray.length, packetSzIndex); //should be static, this would indicate a major error
    }
    packetAmtIndex = txIndexArray.length / packetSzIndex;

    //-------------------------------- Calc Sequence data size, and pad it ----------------------------------------------

    let packetSzSeq = stateDevice.soft.packetsSize.seqBlock;
    let packetAmtSeq = 0;

    if ((txSeqArray.length % packetSzSeq) > 0) {
        //console.log("PACKET TOO SMALL, PADDING", txSeqArray.length); // this is normal
        let len = txSeqArray.length;
        txSeqArray.length = (Math.ceil(txSeqArray.length / packetSzSeq)) * packetSzSeq;
        txSeqArray.fill(33, len); //fill empty/undefined with 0 - 33 is DEBUG
        txSeqArray.fill(33, len); //fill empty/undefined with 0 - 33 is DEBUG
    }
    packetAmtSeq = txSeqArray.length / packetSzSeq;

    //------------------------- Start sending ----------------------------------------------------

    console.log("tx array lengths: " + txIndexArray.length, txSeqArray.length); //DEDBUG
    console.log(txIndexArray)


    //DEVELOPMENT - create an assembly file with the sequences and Index
    // let devBuffer = [...txIndexArray]
    // devBuffer.push(...txSeqArray)
    // developmentGenerateAssembly(devBuffer)

    uxProgressBarFake(0, 100, 250); //0 start, 100 end, 100mS
    uxProgressBarEvent(); //show/run progress bar

    auroraCMD.requestFullUpload(packetAmtIndex, packetAmtSeq, packetSzSeq, packetSzIndex, txIndexArray, txSeqArray, (mainObj.userIndex.length - 1), mainObj.seq[mainObj.idleSeqID].linker.virtualID, function () {
        pushMessageToLog("Successfully uploaded the Index and Color Sequences");
    });

    //------------------------------------------------------------------------------

    //remove temp linker object from .seq
    mainObj.seq.forEach(function (v, i) {
        if (v.hasOwnProperty('linker')) {
            delete mainObj.seq[i].linker;
        }
    });

    //------------------------------------------------------------------------------

    function helperIndexPacker(val) {
        let breakArr;
        switch (stateDevice.soft.indexMemoryModel) {
            case 0: //16-bit, standard - NOT TESTED
                txIndexArray.push(getValue16BitLSB(val));
                txIndexArray.push(getValue16BitMSB(val));
                break;
            case 1: //16-bit, fillUpper - NOT TESTED
                txIndexArray.push(getValue16BitLSB(val));
                txIndexArray.push(getValue16BitMSB(val));
                txIndexArray.push(0); //fillUpper padding
                break;
            case 2: //32-bit, standard - NOT TESTED
                breakArr = getBreak32BitValue(val);
                txIndexArray.push(breakArr[3]); //LSB
                txIndexArray.push(breakArr[2]);
                txIndexArray.push(breakArr[1]);
                txIndexArray.push(breakArr[0]); //MSB
                break;
            case 3: //32-bit, fillUpper
                breakArr = getBreak32BitValue(val);
                txIndexArray.push(breakArr[3]); //LSB
                txIndexArray.push(breakArr[2]);
                txIndexArray.push(0); //fillUpper padding
                txIndexArray.push(breakArr[1]);
                txIndexArray.push(breakArr[0]); //MSB
                txIndexArray.push(0); //fillUpper padding                
                break;
        } //end switch
    }
}

//========================================================================================================================================

function commSetUserIDValue() {
    console.log("commSetUserIDValue()");
    let userID = parseInt(document.getElementById("ws-hardware-useridbox").value);
    auroraCMD.setUserIDNumber(userID);
}

//========================================================================================================================================

function commUploadHWPV(seqID) {
    console.log("commUploadHWPV(" + seqID + ")");
    if (stateCommunication.connected == false) {
        pushMessageToLog("No NLED device is connected, can not upload Hardware Preview.");
        if (stateCommunication.autoHWPVEnable) uxAutoHWPVSwitch(false);
        return;
    }

    let seq = mainObj.seq[seqID];//get object reference
    sequenceMeasure(seq); //update the length before sending

    console.log(seq.memory, stateDevice.soft.hwpvSize);

    if (seq.memory > stateDevice.soft.hwpvSize) {
        pushMessageToLog("Sequence is too large to preview on hardware.");
        return;
    }

    if (seq.mode == 'mList') {
        pushMessageToLog("List sequence modes can not be previewed on hardware.");
        return;
    }

    //console.log("Running HWPV with ", seq.memory);
    let transPacket = [];
    commPackSequence(seq, 'hwpv', transPacket); //get the sequence data packet, with header

    let packetSz = stateDevice.soft.packetsSize.hwpvBlock;
    let packetAmt = 0;

    if ((transPacket.length % packetSz) > 0) {
        //console.log("PACKET TOO SMALL, PADDING", transPacket.length); // this is normal
        let len = transPacket.length;
        transPacket.length = (Math.ceil(transPacket.length / packetSz)) * packetSz;
        transPacket.fill(33, len); //fill empty/undefined with 0 - 33 is DEBUG
    }
    //console.log(transPacket);

    packetAmt = transPacket.length / packetSz;
    console.log("======== PACKET READY ===========", packetSz, packetAmt, transPacket.length);

    uxProgressBarFake(0, 5, 50); //start 0, end 5, 50mS
    uxProgressBarEvent(); //show/run progress bar - //what about if it gets really big? can it also use normal?

    auroraCMD.requestHWPVUpload(packetAmt, packetSz, transPacket, function () {
        pushMessageToLog("Successfully uploaded a Hardware Preview with:" + seq.name);
    });
}

//========================================================================================================================================

function commPackSequence(seq, mode, sendArr) {
    console.log("commPackSequence() with " + seq.name);

    sequenceValidateData(seq); //added 8-20-2020, couldn't hurt right? way to many source sof data corruption

    // let sendArr = []; //scratch
    let devChans = stateDevice.soft.channels;
    //let chanSz = ((devChans > seqChans) ? seqChans : devChans); // will crop the off any persistant data and/or will limit to the device's channel size
    let chanSz = sequenceGetChannelAmount(seq);

    //----------------------- Handle Maximum Number of Channels -----------------------------

    if (seq.mode != 'mList') {
        if (stateDevice.soft.lockChannelSize) {
            //arrays might not be large enough..... or too large. Can only be the same
            if (stateDevice.soft.channels != sequenceGetChannelAmount(seq)) {
                // console.log("HERE", stateDevice.soft.channels, seq.numPixels, getColorModeMult(seq.colorMode))
                chanSz = stateDevice.soft.channels; //if the device uses locksChannelSize, force it to the same size
                pushMessageToLog(`The device does not support the number of pixels specifed in the sequence '${seq.name}'. Channels: ${seq.numPixels * getColorModeMult(seq.colorMode)} of
              ${stateDevice.soft.channels} maximum. Uploaded data was modified for compatibility.`);
            }
        }
        else {  //lockChannelSize is false
            let maxChans = ((seq.mode == 'mFile') ? stateDevice.soft.channelsExt : stateDevice.soft.channels);
            console.log(strRed("-------------------------------------------"), maxChans)
            if (sequenceGetChannelAmount(seq) > maxChans) {
                chanSz = maxChans;
                pushMessageToLog(`The device does not support the number of pixels specifed in the sequence '${seq.name}'. Channels: ${seq.numPixels * getColorModeMult(seq.colorMode)} of
                   ${maxChans} maximum. Uploaded data was modified for compatibility.`);
            }
        }
    }

    //----------------------- Handle Maximum Number of Frames -----------------------------

    let frameSz = seq.frames;
    if (cDataSeqModeGlobal.includes(seq.mode)) {
        if (seq.frames > stateDevice.soft.maxFramesExt) frameSz = stateDevice.soft.maxFramesExt; //set to extended max, 65,535
    }
    else {
        if (seq.frames > stateDevice.soft.maxFrames) frameSz = stateDevice.soft.maxFrames; //set to standard max, 256. Frames are base 1 in this case
    }

    //--------------------------------- Start -------------------------------------------

    let intensity = 1;
    //HWPV does not use global intensity
    if (mainObj.globalIntensityEnable && mode == 'full') {
        //global and per sequence are applied to each other
        intensity = mainObj.globalIntensity / 100;
        intensity *= (seq.intensity / 100); //convert to float from percentage
    }
    else intensity = seq.intensity / 100; //convert to float from percentage

    console.log("Using intensity of " + intensity + " for upload of sequence " + seq.name)

    //------------------------- Header, Ver2 --------------------------------------------

    let memAdr = 0;
    if (mode == 'full') memAdr = seq.linker.mapAdr;
    console.log(memAdr)
    let breakArr = getBreak32BitValue(memAdr);
    sendArr.push(breakArr[0]); //32-bit Index adr - MSB
    sendArr.push(breakArr[1]);
    sendArr.push(breakArr[2]);
    sendArr.push(breakArr[3]); //32-bit Index adr - LSB
    sendArr.push(convertSequenceModeV2(seq));
    sendArr.push(getValue16BitMSB(frameSz - 1)); //frames is base 0
    sendArr.push(getValue16BitLSB(frameSz - 1));
    sendArr.push(0); //32-bit speed MSB
    sendArr.push(0);
    sendArr.push(getValue16BitMSB(seq.speed));
    sendArr.push(getValue16BitLSB(seq.speed)); //32-bit speed LSB
    sendArr.push(getValue16BitMSB(chanSz)); //channels
    sendArr.push(getValue16BitLSB(chanSz)); //channels
    sendArr.push(convertSequenceFlags(seq)); //Sequence flags
    if (seq.mode == 'mPOV') sendArr.push(seq.povGridSpeed); //POV mode
    else sendArr.push(0); //empty slot
    if (seq.packetClone != undefined) sendArr.push(seq.packetClone); //packet clone
    else sendArr.push(0);

    //------------------------- Per Sequence Mode Actions --------------------------------------------

    if (seq.mode == 'mList') {
        sendArr.push(...seq.linker.listID); //.linker one contains virtual IDs
        sendArr.push(...seq.listFlags); //8-bit

        let interations = [];

        seq.listIteration.forEach(function (v, i) {
            interations.push(getValue16BitLSB(seq.listIteration[i])); //why is this LSB first..... correct.
            interations.push(getValue16BitMSB(seq.listIteration[i]));
        });
        sendArr.push(...interations); //16-bit
    }
    else {  //All sequence modes except mList
        //some arrays can be larger than channel amount due to data persistance. Crop it off
        if (cSeqModesStartVals.includes(seq.mode)) {
            //per or global intensity.....

            if (stateDevice.soft.bit16Data) {
                if (seq.startVals.length > chanSz || stateDevice.soft.lockChannelSize) sendArr.push(...systemResize16Array(seq.startVals, chanSz).map(e => e * intensity)); //crop it down
                else sendArr.push(...systemResize16Array(seq.startVals, seq.startVals.length).map(e => e * intensity)); //do not crop
            }
            else {
                if (seq.startVals.length > chanSz || stateDevice.soft.lockChannelSize) sendArr.push(...systemResize8Array(seq.startVals, chanSz).map(e => e * intensity)); //crop it down
                else sendArr.push(...seq.startVals.map(e => e * intensity));
            }
        }

        if (seq.mode == 'mInstant' || seq.mode == 'mScene') { //mScene is v2 emulation
            //place dummy startVals... which are sent but not used, or only used for transitions or something....
            let dummyArr = [];

            for (let i = 0; i < chanSz; i++) {
                //console.log(seq.frameVar.length, i)
                if (seq.mode == 'mScene') {
                    //scene emulation
                    if (seq.dataFrames[0].length > i) {
                        if (stateDevice.soft.bit16Data) {
                            dummyArr.push((seq.dataFrames[0][i] >> 8) & 0x00FF); //MSB
                            dummyArr.push((seq.dataFrames[0][i] & 0x00FF)); //LSB
                        }
                        else dummyArr.push(seq.dataFrames[0][i]);
                    }
                    else {
                        dummyArr.push(0);
                        if (stateDevice.soft.bit16Data) dummyArr.push(0); //if 16-bit data push another 0
                    }


                }
                else { //it is mInstant
                    if (seq.frameVar.length > i) {
                        if (seq.frameVar[i] >= frameSz) {
                            dummyArr.push(0); //if frameVar indicates a frame that is too large, it sets it to 0
                            if (stateDevice.soft.bit16Data) dummyArr.push(0); //if 16-bit data push another 0
                        }
                        else {
                            if (stateDevice.soft.bit16Data) {
                                dummyArr.push((seq.dataFrames[seq.frameVar[i]][i] >> 8) & 0x00FF); //MSB
                                dummyArr.push(seq.dataFrames[seq.frameVar[i]][i] & 0x00FF); //LSB
                            }
                            else dummyArr.push(seq.dataFrames[seq.frameVar[i]][i]);
                        }
                    }
                    else {
                        dummyArr.push(0); //handles lockChannelSize, got here with under-sized arrays
                        if (stateDevice.soft.bit16Data) dummyArr.push(0); //if 16-bit data push another 0
                    }
                }
            }

            sendArr.push(...dummyArr);
        }
        //-----------------------------------------------------------------------------------
        if (cDataSeqModesDataFrames.includes(seq.mode)) {
            if (seq.frameVar.length > chanSz || stateDevice.soft.lockChannelSize)
                sendArr.push(...systemResize8Array(seq.frameVar, chanSz).map(e => { if (e >= frameSz) e = 0; return e; })); //crop or expand it and check it
            else sendArr.push(...seq.frameVar.map(e => { if (e >= frameSz) e = 0; return e; }));//checks each value to ensure it is not over the max frames for the seq.mode
        }
        else if (seq.mode == 'mScene') {
            sendArr.push(...new Array(chanSz).fill(0)); //mScene emulation as an instant
        }

        if (seq.mode == 'mInstant' || seq.mode == 'mScene') { //mScene is v2 emulation
            //place dummys for Slide frames, and Slide frame flags. 8-bit each, 1 set(16-bits) per frame
            sendArr.push(...new Array(frameSz * 2).fill(0));
        }

        //per or global intensity.....
        for (let i = 0; i < frameSz; i++) {
            if (seq.mode == 'mGradient') {

                if (stateDevice.soft.bit16Data) {
                    if (seq.dataFrames[i].length > 4) sendArr.push(...systemResize16Array(seq.dataFrames[i], 4).map(e => e * intensity));
                    else sendArr.push(...systemResize16Array(seq.dataFrames[i], seq.dataFrames[i].length).map(e => e * intensity));
                }
                else {
                    if (seq.dataFrames[i].length > 4) sendArr.push(...systemResize8Array(seq.dataFrames[i], 4).map(e => e * intensity));
                    else sendArr.push(...seq.dataFrames[i].map(e => e * intensity));
                }
            }
            else {
                if (stateDevice.soft.bit16Data) {
                    if (seq.dataFrames[i].length > chanSz || stateDevice.soft.lockChannelSize) sendArr.push(...systemResize16Array(seq.dataFrames[i], chanSz).map(e => e * intensity));
                    else sendArr.push(...systemResize16Array(seq.dataFrames[i], seq.dataFrames[i].length).map(e => e * intensity));
                }
                else {
                    if (seq.dataFrames[i].length > chanSz || stateDevice.soft.lockChannelSize) sendArr.push(...systemResize8Array(seq.dataFrames[i], chanSz).map(e => e * intensity));
                    else sendArr.push(...seq.dataFrames[i].map(e => e * intensity));
                }
            }
        }
    } //end else

    //------------------------------------------------------------------------

    //removed - no longer works since the send buffer is passed to this function
    // if (sendArr.length != seq.memory) {
    //     console.error("Built packet for sequence is not the correct size. ERROR!!!!!!! SendSz:", sendArr.length, "  SeqSz:", seq.memory);
    //  console.log(sendArr); //DEBUG
    // }

    //------------------------------------------------------------------------
}

//========================================================================================================================================

function commUploadGammaTable() {
    console.log("commUploadGammaTable()");

    //---------------------------------------------------------------

    if (stateCommunication.connected == false) {
        pushMessageToLog("No NLED device is connected, can not upload Gamma Table or Values.");
        return;
    }

    //----------------------- Already ran in render, but be certain ----------------------------------------

    if (gammaTables.red.length == 0) gammaTables.red = cDefaultGammaTable;
    if (gammaTables.green.length == 0) gammaTables.green = cDefaultGammaTable;
    if (gammaTables.blue.length == 0) gammaTables.blue = cDefaultGammaTable;
    if (gammaTables.white.length == 0) gammaTables.white = cDefaultGammaTable;

    //---------------------------------------------------------------

    let builtArr = [];

    //0: None. 1: 8-bit gamma table old method. 2: 8bit gamma new method. 3: 16-bit calculation
    switch (stateDevice.soft.gammaMode) {
        case 0: //None

            break;
        case 1: //8bit table, old method(single table)
            //not implmented, use white table
            break;
        case 2:  //8bit table, fillUpper, new method(table for each color)
            packHelperMode2(gammaTables.red);
            packHelperMode2(gammaTables.green);
            packHelperMode2(gammaTables.blue);
            packHelperMode2(gammaTables.white);
            break;
        case 3: //16bit calculation

            break;
    } //end mode switch

    //----------------------------------------------------------------

    //console.log(builtArr);

    console.log("Prepared Gamma Table Array for mode#" + stateDevice.soft.gammaMode + "   Len: ", builtArr.length);

    let packetSz = stateDevice.soft.packetsSize.gammaBlock;
    let packetAmt = 0;

    if ((builtArr.length % packetSz) > 0) {
        console.error("PACKET NOT THE CORRECT SIZE, PADDING. ERROR!", builtArr.length); // this is a major error
        return; // what to do about it? padding is not the answer
    }

    packetAmt = builtArr.length / packetSz;
    console.log("======== GAMMA PACKET READY ===========", packetSz, packetAmt, builtArr.length);

    //----------------------------------------------------------------

    uxProgressBarFake(0, 5, 50); //start 0, end 5, 50mS
    uxProgressBarEvent(); //will base bar off packets

    auroraCMD.requestGammaUpload(packetAmt, stateDevice.soft.packetsSize.gammaBlock, builtArr, function () {
        pushMessageToLog("Gamma correction table uploaded successfully.");
    });

    //----------------------------------------------------------------

    function packHelperMode2(arr) {
        let x = 0;
        for (let i = 0; i < 128; i++) {
            builtArr.push(arr[x++]);
            builtArr.push(arr[x++]);
            builtArr.push(0); //fill upper padding
        }
    }

    //----------------------------------------------------------------
}

//========================================================================================================================================

function commDownloadGammaTable() {
    console.log("commDownloadGammaTable()");
    //waiting to implement, will need new firmware

}

//========================================================================================================================================

function convertSequenceModeV2(seq) {
    switch (seq.mode) {
        default:
        case "mStall":
            return 0;
        case "mFade":
            return 1;
        case "mGradient":
            return 2;
        case 'mScene':   //NO mSCENE YET - v3, so emulate for v2
        case "mInstant":
            return 3;
        case "mTech":
            return 4;
        case "mPOV":
            return 5;
        case "mFile":
            return 6;
        case "mList":
            return 7;

    } //end switch
}

//========================================================================================================================================

function convertSequenceFlags(seq) {

    let tempFlags = 0; //start with all 0s
    tempFlags = helperColorMode();
    tempFlags = (helperPlayMode() << 2) | tempFlags;
    tempFlags = (helperTransMode() << 5) | tempFlags;
    //console.log("tempFlags: " + tempFlags, getValue16BitBinary(tempFlags));
    return tempFlags;

    //----------------------------------------------------------------
    function helperColorMode() {
        switch (seq.colorMode) {
            case 'Mono':
                return 0;
            case 'RGB':
                return 1;
            case 'RGBW':
                return 2;
        }
    }
    //----------------------------------------------------------------
    function helperPlayMode() {
        switch (seq.playMode) {
            case 'playLoop':
                return 0;
            case 'playNext':
                return 1;
            case 'playStart':
                return 2;
            case 'playEnd':
                return 3;
            case 'playBlank':
                return 4;
            case 'playIdle':
                return 5;
        }
    }
    //----------------------------------------------------------------
    function helperTransMode() {
        switch (seq.transition) {
            case 'transInstant':
                return 0;
            case 'transFastFade':
                return 1;
            case 'transSlowFade':
                return 2;
        }
    }
    //----------------------------------------------------------------
}

//========================================================================================================================================

function convertPlayModeText(str) {
    //const cPlayModes = ["playLoop","playNext","playStart","playEnd","playBlank","playIdle"];
    switch (str) {
        case 'playLoop':
            return "Loop";
        case 'playNext':
            return "One-Shot Next";
        case 'playStart':
            return "One-Shot Start";
        case 'playEnd':
            return "One-Shot End";
        case 'playBlank':
            return "One-Shot Blank";
        case 'playIdle':
            return "One-Shot Idle";
    }
}

//========================================================================================================================================
