'use strict';

//========================================================================================================================================

function indexMemoryGaugeRefresh() {
    console.log("indexMemoryGaugeRefresh()")

    let memWidth = ((mainObj.indexedMemory / stateDevice.soft.dataSize) * 100);

    if (memWidth > 100) {
        memWidth = 100;
        document.getElementById("ws-connection-memoryused").style.backgroundColor = 'var(--nled-red)';
    }
    else document.getElementById("ws-connection-memoryused").style.backgroundColor = 'var(--nled-green)';

    document.getElementById("ws-connection-memoryused").style.width = memWidth + "%";
    document.getElementById("ws-connection-memused").innerText = sequenceMemoryLabel(mainObj.indexedMemory);

    let total = sequenceMemoryLabel(stateDevice.soft.dataSize);
    if (total.includes('undefined')) total = 'unknown';
    document.getElementById("ws-connection-memtotal").innerText = total;
}

//========================================================================================================================================

function indexCalculateMemory() {
    if (mainObj.userIndex.length == 0) return; //if no indexes are listed, then just leave

    let totalUsed = 0;
    let tracker = [];

    //console.log(mainObj.seq.length)

    if (mainObj.userIndex.length > 0) {
        mainObj.userIndex.forEach(function (val, index) {
            //console.log(val, index);
            if (!tracker.includes(val)) {
                totalUsed += mainObj.seq[val].memory; //add memory used per sequence to total - all the indexed sequences
                tracker.push(val); //track it
            }
        });
    }

    mainObj.seq.forEach(function (val, index) {
        if (mainObj.userIndex.includes(index)) {
            //Sequence is on the index
            //console.log("user index and " + index);
            if (val.mode == 'mList') {
                //console.log("mList on the index at :", index);
                val.listID.forEach(function (v, i) {
                    //if (!mainObj.userIndex.includes(v)) {
                    //console.log("mList listID[", index, "] does not include ID", v);
                    //should have been caught already unless it is just measuring for index memory gauge
                    if (v == null) {
                        pushMessageToLog("The linked sequence '" + mainObj.seq[index].name + "' contains a sequence that has been deleted. Please review");
                        mainObj.seq[index].errorFlag = true;
                    }
                    else {
                        if (!tracker.includes(v)) {
                            totalUsed += mainObj.seq[v].memory; //add memory used per sequence to total - adds all the extended indexes
                            tracker.push(v); //track it - already checks if on user index
                        }
                    }
                    //}
                });
            }
        }
    });

    if (!mainObj.userIndex.includes(mainObj.idleSeqID) && !tracker.includes(mainObj.idleSeqID)) {
        //console.log("idle sequence thing here");
        totalUsed += mainObj.seq[mainObj.idleSeqID].memory; //idle sequence was not on the index or a mList
    }

    //console.log(tracker)
    mainObj.indexedMemory = totalUsed;
}

//========================================================================================================================================

function indexReset() {
    mainObj.userIndex = [];
    mainObj.indexedMemory = 0; //no need to recalculate, it is 0
    indexRefresh();
    pushMessageToLog("The sequence index has been reset and cleared.");
}

//========================================================================================================================================

function indexReplaceTile(seqID) {
    console.log("indexReplaceTile() " + seqID);
    mainObj.userIndex[stateUX.slotTarget] = parseInt(seqID);
    indexCalculateMemory();
    indexRefresh();
}
//========================================================================================================================================

function indexAddTile(seqID) {
    console.log("indexAddTile() " + seqID, stateUX.slotTarget, mainObj.userIndex.length);
    mainObj.userIndex.splice(stateUX.slotTarget, 0, seqID); //insert
    indexCalculateMemory();
    indexRefresh();
    if (stateUX.slotTarget == mainObj.userIndex.length)
        document.getElementById('ws-connection-index-container').scrollTop = document.getElementById('ws-connection-index-container').scrollHeight;
}

//========================================================================================================================================

function indexDeleteTile(slotID) {
    console.log("indexDeleteTile() " + slotID);
    mainObj.userIndex.splice(slotID, 1); //delete
    indexCalculateMemory();
    indexRefresh();
}

//========================================================================================================================================

