'use strict';

//========================================================================================================================================

var stateUX = {
	activeTab: 'navtab-software',
	activeTool: 'menubar-icon-sequence',
	messageLogIsOpen: false,
	tabElements: {
		'navtab-graphic': {
			show: [
				{ id: 'workspace-graphic', transition: 'height' },
				{ id: 'popout-menu', transition: 'width' },
				{ id: 'frame-bar', transition: 'height' },
				{ id: 'navtab-sequence-menu', transition: 'height' },
				{ id: 'tool-bar', transition: 'width' }
			],
			hide: [
				{ id: 'workspace-timeline', transition: 'height' },
				{ id: 'workspace-connection', transition: 'height' },
				{ id: 'workspace-software', transition: 'height' },
				{ id: 'workspace-hardware', transition: 'height' }
			]
		},
		'navtab-timeline': {
			show: [
				{ id: 'workspace-timeline', transition: 'height' },
				{ id: 'popout-menu', transition: 'width' },
				{ id: 'frame-bar', transition: 'height' },
				{ id: 'navtab-sequence-menu', transition: 'height' },
				{ id: 'tool-bar', transition: 'width' }
			],
			hide: [
				{ id: 'workspace-graphic', transition: 'height' },
				{ id: 'workspace-connection', transition: 'height' },
				{ id: 'workspace-software', transition: 'height' },
				{ id: 'workspace-hardware', transition: 'height' }
			]
		},
		'navtab-connection': {
			show: [{ id: 'workspace-connection', transition: 'height' }],
			hide: [
				{ id: 'workspace-timeline', transition: 'height' },
				{ id: 'workspace-graphic', transition: 'height' },
				{ id: 'workspace-software', transition: 'height' },
				{ id: 'workspace-hardware', transition: 'height' },
				{ id: 'popout-menu', transition: 'width' },
				{ id: 'frame-bar', transition: 'height' },
				{ id: 'navtab-sequence-menu', transition: 'height' },
				{ id: 'tool-bar', transition: 'width' }
			]
		},
		'navtab-software': {
			show: [{ id: 'workspace-software', transition: 'height' }],
			hide: [
				{ id: 'workspace-timeline', transition: 'height' },
				{ id: 'workspace-graphic', transition: 'height' },
				{ id: 'workspace-connection', transition: 'height' },
				{ id: 'workspace-hardware', transition: 'height' },
				{ id: 'popout-menu', transition: 'width' },
				{ id: 'frame-bar', transition: 'height' },
				{ id: 'navtab-sequence-menu', transition: 'height' },
				{ id: 'tool-bar', transition: 'width' }
			]
		},
		'navtab-hardware': {
			show: [{ id: 'workspace-hardware', transition: 'height' }],
			hide: [
				{ id: 'workspace-timeline', transition: 'height' },
				{ id: 'workspace-graphic', transition: 'height' },
				{ id: 'workspace-connection', transition: 'height' },
				{ id: 'workspace-software', transition: 'height' },
				{ id: 'popout-menu', transition: 'width' },
				{ id: 'frame-bar', transition: 'height' },
				{ id: 'navtab-sequence-menu', transition: 'height' },
				{ id: 'tool-bar', transition: 'width' }
			]
		}
	},
	frameScroll: {
		scrollTimer: 0,
		target: 0,
	},
	userConfirmOpen: false,
	patchFilePath: "",
	refreshGraphic: true,
	refreshTimeline: true,
	updateGraphic: false,
	updateTimeline: false,
	fileDialogOpen: false,
	fileDialogFirstOpen: {
		sequenceFile: false,
		povFile: false,
		gammaFile: false,
		patchFile: false,
		seqModeFile: false,

	},
	zoneView: 1,
	seqTarget: '',
	slotTarget: 0,
	liveControlElem: '',
	indicatorDragging: '',
	indicatorMax: 0,
	indicatorStep: 0,
	toolCoordX: 0,
	toolCoordY: 0,
	mouseTimer: null,
	serialPortScanTimer: null,
	overlayMenuTimer: null,
	windowResizeTimer: null,
	layoutManualEnable: false,
	layoutAdvancedPreview: false,
	toolPaintEnable: false,
	paintManColor: [0, 0, 0, 0],
	paintFuncColor: [0, 0, 0, 0],
	mouseDown: false,
	toolZoneAssign: false,
	undoRedoObj: [],
	undoRedoLevel: -1,
	undoRedoFlag: false,
	undoRedoStamp: 1,
	undoRedoDisable: false,
	shapeCenterEnable: false,
	interactionElem: {
		node: '',
		num: 0
	},
	softwarePrevPlay: false,
	softwarePrevTimer: null,
	softwarePlayCount: 0,
	targetSaveFile: fileFixPath(path.join(process.cwd(), 'saves/temp.auroraseq')),
};

//========================================================================================================================================

function fileConfirmMessagesJSON() {
	userConfirm = JSON.parse(fs.readFileSync(path.join(process.cwd(), 'assets/json/confirm-messages.json'), 'utf8'));
}

//========================================================================================================================================

function overlayPromptEvent(event, operation, target, arg1) {
	console.log("overlayPromptEvent()",target,operation);
	const elsToToggle = document.querySelectorAll('#overlay-menu-fog, #overlay-prompt-container, #overlay-prompt');
	// const testelsToToggle = document.getElementById("overlay-prompt-container").querySelectorAll('[id^="prompt-"]');

	if (operation === 'open') {

		document.getElementById("overlay-menu-fog").style.zIndex = 21;

		for (let i = 0; i < elsToToggle.length; i++) {
			elsToToggle[i].classList.remove('visibility-hidden');
			elsToToggle[i].classList.add('visibility-visible');
		}

		//------------------------------- Make All Hidden --------------------------------------
		// testelsToToggle.forEach(function (el) {
		// 	el.classList.add('visibility-hidden');
		// 	el.classList.remove('visibility-visible');
		// });

		//now show the target
		//document.getElementById("overlay-menu-container").style.width = document.getElementById(target).style.width;
		//document.getElementById("overlay-menu-container").style.height = document.getElementById(target).style.height;

		document.getElementById(target).classList.remove('visibility-hidden');
		document.getElementById(target).classList.add('visibility-visible');
	}
	else {
		document.getElementById("overlay-menu-fog").style.removeProperty('z-index');

		for (let i = 0; i < elsToToggle.length; i++) {
			elsToToggle[i].classList.remove('visibility-visible');
			elsToToggle[i].classList.add('visibility-hidden');
		}



		console.log("----------------",stateUX.targetMenu);
if(stateUX.targetMenu != undefined) {
	document.getElementById("overlay-menu-fog").classList.remove('visibility-hidden');
	document.getElementById("overlay-menu-fog").classList.add('visibility-visible');

}

		// testelsToToggle.forEach(function (el) {
		// 	el.classList.add('visibility-hidden');
		// 	el.classList.remove('visibility-visible');
		// });


	}

}

//========================================================================================================================================

function overlayMenuEvent(event, operation, target, arg1) {
	console.log("overlayMenuEvent()",target,operation);

	const elsToToggle = document.querySelectorAll('#overlay-menu-fog, #overlay-menu-container, #overlay-menu');
	const testelsToToggle = document.getElementById("overlay-menu-container").querySelectorAll('[id^="menu-"]');

	if (operation === 'open') {

		stateUX.targetMenu = target; //set UX state to track the open menu for later close callback

		for (let i = 0; i < elsToToggle.length; i++) {
			elsToToggle[i].classList.remove('visibility-hidden');
			elsToToggle[i].classList.add('visibility-visible');
		}

		//------------------------------- Make All Hidden --------------------------------------
		testelsToToggle.forEach(function (el) {
			// console.log(el.id);
			el.classList.add('visibility-hidden');
			el.classList.remove('visibility-visible');
		});

		//now show the target
		//document.getElementById("overlay-menu-container").style.width = document.getElementById(target).style.width;
		//document.getElementById("overlay-menu-container").style.height = document.getElementById(target).style.height;

		document.getElementById(target).classList.remove('visibility-hidden');
		document.getElementById(target).classList.add('visibility-visible');

		//now that it is not hidden/none, the width can be read
		//console.log("this: "+document.getElementById(target).offsetWidth)
		//console.log(window.innerWidth)
		//console.log((window.innerWidth - document.getElementById(target).offsetWidth) / 2);

		//center it
		document.getElementById("overlay-menu-container").style.left = ((window.innerWidth - document.getElementById(target).offsetWidth) / 2) - 10 + "px";
		document.getElementById("overlay-menu-container").style.top = ((window.innerHeight - document.getElementById(target).offsetHeight) / 2) - 10 + "px";

		// const bounding =  document.getElementById(target).getBoundingClientRect();
		// console.log(bounding);
		// document.getElementById("overlay-menu-container").style.left = ((window.innerWidth - bounding.width) / 2) + "px";
		// document.getElementById("overlay-menu-container").style.top = ((window.innerHeight - bounding.height) / 2) + "px";

		//--------------------------- open callback, thought it was easier to define here than with the onClick ----------------------------------------

		console.log(target + " open callback");

		switch (target) {
			case 'menu-1': //Primary Sequence Menu
				ovmSequenceSelectRefresh("ovmenu-1-workspace");
				break;
			case 'menu-2': //Live Control
				//checks to see if menu is empty, then refresh, otherwise persist until user changes ViewMode
				if (document.getElementById('ovmenu-2-workspace').childElementCount == 0) ovmLiveControlUpdate(true);
				else ovmLiveControlUpdate(false);
				if (stateCommunication.connected == true) {
					stateUX.overlayMenuTimer = setInterval(function () {
						if (stateCommunication.liveUpdatePending == true) {
							stateCommunication.liveUpdatePending = false;
							auroraCMD.setLiveControlPacket(stateCommunication.liveControlPacket);
						}
					}, 50);
					setTimeout(() => { stateCommunication.liveUpdatePending = true }, 100); //send initial live frame
				}
				break;
			case 'menu-3': //stand-alone

				break;
			case 'menu-4': //gamma correction
				ovmGammaRender();
				break;
			case 'menu-5': //sequence target
				stateUX.seqTarget = arg1;
				ovmSequenceSelectRefresh("ovmenu-5-workspace");
				break;
			case 'menu-pixelmapper':
				console.log("OPEN CALLBACK");
				if (mainObj.layout.shape == "shapeMap") {
					let iframe = document.getElementById("ovmenu-pixelmapper-iframe");

					console.log(mainObj.layout.patchCoords)


					let mapObj = []
					//[{"x":18,"y":11},{"x":12,"y":9},{"x":11,"y":8},{"x":3,"y":6}]

					for (const i in mainObj.layout.patchCoords) {
						let coords = mainObj.layout.patchCoords[i].split(",");
						mapObj.push({ x: (Number(coords[0]) - 1), y: (Number(coords[1]) - 1) });
					}

					iframe.contentWindow.postMessage(JSON.stringify(mapObj), "*");
				}
				break;
		} //end switch
	}
	else if (operation === 'close') { //closes everything regardless of what is open


		//---------------- close callback, thought it was easier to define here than with the onClick ----------------------

		console.log(target+ " close callback");
		switch (stateUX.targetMenu) {
			case 'menu-1': //Primary Sequence Menu
				if (SelSeq.mode == 'mList') refreshLayouts(); //sloppy I think, in case  a sequence is deleted and user closes menu while selected a list it needs to update the list layout
				break;
			case 'menu-2': //live control
				clearInterval(stateUX.overlayMenuTimer);
				//leaving it in live mode for now, otherwise send command here
				if (stateCommunication.connected) auroraCMD.setLiveControlMode(false, 0, 0); //enable, 8-bit data, using local channels
				break;
			case 'menu-3': //stand-alone

				break;
			case 'menu-4': //gamma menu
				document.getElementById("ovmenu-4-workspace").innerHTML = ""; //clear workspace container, lots of nodes, save memory and performance maybe
				break;
			case 'menu-5': //sequence select

				break;
			case 'menu-pixelmapper':

				//update this
				// let msg = confirm("Sure you want to close?");
				// if(!msg) return;
				overlayPromptEvent(event, 'open', 'prompt-pixelmapperclose');
				return;
				break;
		} //end switch

		for (let i = 0; i < elsToToggle.length; i++) {
			elsToToggle[i].classList.remove('visibility-visible');
			elsToToggle[i].classList.add('visibility-hidden');
		}

		testelsToToggle.forEach(function (el) {
			el.classList.add('visibility-hidden');
			el.classList.remove('visibility-visible');
		});


		stateUX.targetMenu = undefined;
	}
}

//========================================================================================================================================

function uxTipsAndLabelsUpdate(lang = 'en') {
	console.log("uxTipsAndLabelsUpdate() lang: " + lang)

	// labelsKeys[i] is the key/selector(ie 'navtab-graphic-text')
	// labels[labelsKeys[i]][lang] is the value (ie 'Graphic' for lang = 'en')
	//will want to to try to load the 'sp' translations, but if not, use 'en' labels

	//load labels data into holder
	fetch(path.join(process.cwd(), 'assets/json/tooltips.json'))
		.then((resp) => resp.json())
		.then(function (tooltipsData) {

			//console.log(tooltipsData);

			//----------------------------- create tooltip elements for tools ------------------------------------------

			let toolElements = Array.from(
				// add tool tip if listed on JSON
				document.querySelectorAll('div, button, select, input, label, textarea')
			);

			for (let i = 0; i < toolElements.length; i++) {
				const id = toolElements[i].id;
				const tooltipId = `${id}`; //any ID on the json file

				//checks if the tooltip for the ID is defined in lables.json, if it is add the tooltip class, otherwise don't
				if (tooltipsData.hasOwnProperty(tooltipId)) {
					uxToolTipAttach(document.getElementById(id), 'fill');
				} //end if
				//else tooltip not found on json
			}

			//----------------- apply tooltips text for selected language ------------------------------

			try {
				const tooltipsKeys = Object.keys(tooltipsData);

				for (let i = 0; i < tooltipsKeys.length; i++) {
					let el = document.getElementById(tooltipsKeys[i]); //get element

					//set textContent of element with lang value. if lang entry is not found, use english
					let language = lang; //make a local that will be altered if indicated lang is not defined
					if (tooltipsData[tooltipsKeys[i]][lang] == undefined) language = 'en'; //default to english if not defined

					if (el && (typeof tooltipsData[tooltipsKeys[i]][language] === 'string')) {
						//console.log(el);
						if (el.hasAttribute("data-tiptext")) {
							el.setAttribute('data-tiptext', tooltipsData[tooltipsKeys[i]][language]); //assign tooltip
						}
					}
				} //end for
			}
			catch (err) {
				console.error(err);
			}
		});


	//----------------- apply labels for text elements for selected language ------------------------------

	let textLabels;
	//load labels data into holder
	fetch(path.join(process.cwd(), 'assets/json/labels.json'))
		.then((resp) => resp.json())
		.then(function (textLabelsData) {
			textLabels = textLabelsData;
			try {
				const textLabelsKeys = Object.keys(textLabelsData);
				for (let i = 0; i < textLabelsKeys.length; i++) {
					let el = document.getElementById(textLabelsKeys[i]); 			//get element
					//set textContent of element with lang value,  if lang entry is not found, use english
					let language = lang; //make a local that will be altered if indicated lang is not defined
					if (textLabelsData[textLabelsKeys[i]][lang] == undefined) language = 'en'; //default to english if not defined

					if (el && (typeof textLabelsData[textLabelsKeys[i]][language] === 'string' || typeof textLabelsData[textLabelsKeys[i]][language] === 'number')) {
						//console.log(el.tagName.toLowerCase())
						switch (el.tagName.toLowerCase()) {
							case 'span':
							case 'div':
							case 'h1':
							case 'h2':
								el.innerHTML = textLabelsData[textLabelsKeys[i]][language].toString(); //assign text string / label
								break;
							case 'button':
							case 'label':
								//console.log(el)
								el.innerText = textLabelsData[textLabelsKeys[i]][language].toString(); //assign text string / label
								break;
						}
					}
				} //end for
			}
			catch (err) {
				console.log(err);
			}
		});
}

//========================================================================================================================================

function selectClick(e) {
	//get the elements id
	//console.log("selectClick()", e);

	const elId = e.getAttribute('id');
	//console.log("selectClick() " + elId);
	const elClasses = document.getElementById(elId).classList;
	const statefulTypes = ['tab-button', 'tool-button', 'frame-icon'];
	statefulTypes.forEach(function (type) {
		if (elClasses.contains(type)) {
			if (type == 'tab-button') {
				//moves the active tab to the bottom of the parent DOM, so it always slides up
				let ws = elId.replace("navtab-", "workspace-")
				let d = document.getElementById(ws);
				d.parentNode.append(d);
			}
			setActive(type, elId);
		}
		uxHideOrShowElements(elId);
	});
}

//========================================================================================================================================

//hide or show sections for each tab
function uxHideOrShowElements(selectedId) {
	//console.log("uxHideOrShowElements() "+selectedId)
	let tabKeys = Object.keys(stateUX.tabElements);
	if (tabKeys.indexOf(selectedId) > -1) {
		const toShow = stateUX.tabElements[selectedId].show;
		for (let i = 0; i < toShow.length; i++) {
			let selector = '#' + toShow[i].id;
			if (toShow[i].transition === 'width') {
				setElementsZeroWidth('remove', selector);
			}
			if (toShow[i].transition === 'height') {
				setElementsZeroHeight('remove', selector);
			}
		}
		const toHide = stateUX.tabElements[selectedId].hide;
		for (let i = 0; i < toHide.length; i++) {
			let selector = '#' + toHide[i].id;
			if (toHide[i].transition === 'width') {
				setElementsZeroWidth('add', selector);
			}
			if (toHide[i].transition === 'height') {
				setElementsZeroHeight('add', selector);
			}
		}
	}
}

//========================================================================================================================================

function uxShowWorkspaceAfterLoad() {
	let workspaces = document.querySelectorAll('[id^="workspace"]');
	//console.log(workspaces); //DEBUG
	for (let i = 0; i < workspaces.length; i++) {
		workspaces[i].classList.remove('visibility-hidden');
	}
}

//========================================================================================================================================

//take the clicked element, removes active class from all others, then sets it to active.
function setActive(selector, newActiveId) {
	const elements = document.getElementsByClassName(selector);
	Array.from(elements).forEach(function (element) {
		element.classList.remove('active');
	});
	document.getElementById(newActiveId).classList.add('active');
}

//if operation is 'add' it disappears, if operation is 'remove' it shows up
function setElementsZeroWidth(operation, selector) {
	let perfMod = ""; //if true, use low-performance mode an disable certain transitions
	if (stateSoftware.lowPerformance) perfMod = "-low";
	let nodes = document.querySelectorAll(selector);
	if (operation === 'add') {
		for (let i = 0; i < nodes.length; i++) {
			nodes[i].classList.remove('show-width-low');
			nodes[i].classList.remove('show-width');
			nodes[i].classList.add('zero-width' + perfMod);
		}
	}
	if (operation === 'remove') {
		for (let i = 0; i < nodes.length; i++) {
			nodes[i].classList.remove('zero-width-low');
			nodes[i].classList.remove('zero-width');
			nodes[i].classList.add('show-width' + perfMod);
		}
	}
}

//if operation is 'add' it disappears, if operation is 'remove' it shows up
function setElementsZeroHeight(operation, selector) {

	let perfMod = ""; //if true, use low-performance mode an disable certain transitions
	if (stateSoftware.lowPerformance) perfMod = "-low";

	let nodes = document.querySelectorAll(selector);
	if (operation === 'add') {
		for (let i = 0; i < nodes.length; i++) {
			nodes[i].classList.remove('show-height-low');
			nodes[i].classList.remove('show-height');
			nodes[i].classList.add('zero-height' + perfMod);
		}
	}
	if (operation === 'remove') {
		for (let i = 0; i < nodes.length; i++) {
			nodes[i].classList.remove('zero-height-low');
			nodes[i].classList.remove('zero-height');
			nodes[i].classList.add('show-height' + perfMod);
		}
	}
}

//========================================================================================================================================

function setMessagesDisplayedBasedOnState() {
	let isOpen = stateUX.messageLogIsOpen;
	const theContainer = document.getElementById('status-bar-message-container');
	if (isOpen) {
		theContainer.classList.replace('status-bar-log-closed', 'status-bar-log-open');
		theContainer.scrollTop = 0; //set div scroll to show top message
	}
	else {
		theContainer.classList.replace('status-bar-log-open', 'status-bar-log-closed');
	}
}

function uxToggleMessageLog(event) {
	console.log("uxToggleMessageLog() " + event);

	const theContainer = document.getElementById('status-bar-message-container');
	theContainer.scrollTop = 0;

	event.stopPropagation(); //prevents further propagation of the current event in the capturing and bubbling phases. Allows click anywhere to close the messages container
	stateUX.messageLogIsOpen = !stateUX.messageLogIsOpen;
	setMessagesDisplayedBasedOnState();
}

//========================================================================================================================================

function uxInitialize() {
	//Can only run once, otherwise buttons will have multiple 'click' event listeners
	console.log("uxInitialize()");

	//----------------- Set Onclick handler's based on class -----------------

	let statefulElements = document.querySelectorAll('.tool-button'); //will probably change this
	statefulElements.forEach(function (el) {
		el.addEventListener('click', function (e) { handleToolIconClick(this) });
	});

	//-----------------------------------------------------------------------

	statefulElements = document.querySelectorAll('.tab-button');
	statefulElements.forEach(function (el) {
		el.addEventListener('click', function (e) { stateUX.activeTab = this.id; selectClick(this); refreshTab(); });
	});

	//-----------------------------------------------------------------------

	//currently only one stepper that is not defined elsewhere
	statefulElements = document.querySelectorAll('.uxNumStepper-up');
	statefulElements.forEach(function (el) {
		el.addEventListener('mousedown', function () { uxElemNumberStepper(this, "up") });
	});

	statefulElements = document.querySelectorAll('.uxNumStepper-down');
	statefulElements.forEach(function (el) {
		el.addEventListener('mousedown', function () { uxElemNumberStepper(this, "down") });
	});


	//---------------------------- Not best way to do it, but need to attach events and no way to check if already has one attached-------------------------------------------

	let excludeList = ['colorpicker-redbox', 'colorpicker-greenbox', 'colorpicker-bluebox', 'colorpicker-whitebox']; //manual list of steppers that already have  input listner

	statefulElements = document.querySelectorAll('.uxNumStepper-value');
	statefulElements.forEach(function (el) {
		el.addEventListener('input', function () { uxElemNumberStepper(this, "set") });
		excludeList.push(el.id);
	});

	//------------------------------ attach oninputs for number box -----------------------------------------------

	//Must be done after number steppers - applied to all input-number fields, so all need a min/max/val
	statefulElements = document.querySelectorAll("input[type='number']");
	statefulElements.forEach(function (el) {
		//if (e.loninput == null) //if not null, it is specifically already defined, so do not overwrite event - color steppers and color picker so far
		if (!excludeList.includes(el.id))
			el.addEventListener('input', function () { uxClampNumberBox(this) }); //no oninput, go ahead and set to default clamper
	});

	//-------------------------------------- attach onclicks for other special steppers  --------------------------------------

	//don't really like this but it works
	document.getElementById('toolmenu-zones-viewup').addEventListener('mousedown', function () { layoutSetZoneViewStepper('up', this) });
	document.getElementById('toolmenu-zones-viewdown').addEventListener('mousedown', function () { layoutSetZoneViewStepper('down', this) });
	document.getElementById('toolmenu-zones-viewval').addEventListener('input', function () { layoutSetZoneViewStepper('set', this) });

	document.getElementById('toolmenu-ledicon-zoneup').addEventListener('mousedown', function () {
		stateUX.zoneView = uxElemNumberStepper(this, "up");
		layoutUpdateBuffers();
	});
	document.getElementById('toolmenu-ledicon-zonedown').addEventListener('mousedown', function () {
		stateUX.zoneView = uxElemNumberStepper(this, "down");
		layoutUpdateBuffers();
	});
	document.getElementById('toolmenu-ledicon-zoneval').addEventListener('mousedown', function () {
		stateUX.zoneView = uxElemNumberStepper(this, "set");
		layoutUpdateBuffers();
	});

	//-------------------------------------- attach onclicks for frame bar --------------------------------------

	document.getElementById('frame-remove-button').addEventListener('click', selectRemoveFrame);
	document.getElementById('frame-insert-button').addEventListener('click', selectInsertFrame);


	//can either do a normal click, or click and hold for 500mS, then it starts to run every 100mS
	document.getElementById('frame-left-button').addEventListener('mousedown', selectLeftFrameClick); //normal click, must be faster than 500mS
	document.getElementById('frame-left-button').addEventListener('mousedown', function (event) {
		document.addEventListener("mouseup", function mouserL() {
			clearTimeout(stateUX.mouseTimer);
			document.removeEventListener('mouseup', mouserL);
		});
		//after 500mS without a mouseup, sets interval to 100mS
		stateUX.mouseTimer = setTimeout(function () {
			stateUX.mouseTimer = setInterval(selectLeftFrameClick, 100, 'click');
		}, 500);
	});

	document.getElementById('frame-right-button').addEventListener('mousedown', selectRightFrameClick);
	document.getElementById('frame-right-button').addEventListener('mousedown', function (event) {
		document.addEventListener("mouseup", function mouserR() {
			clearTimeout(stateUX.mouseTimer);
			document.removeEventListener('mouseup', mouserR);
		});
		stateUX.mouseTimer = setTimeout(function () {
			stateUX.mouseTimer = setInterval(selectRightFrameClick, 100, 'click');
		}, 500);
	});

	document.getElementById('frame-icons-container').addEventListener('wheel', function (e) {
		if (e.deltaY < 0) selectLeftFrameClick();
		else selectRightFrameClick();
	});

	document.getElementById('ws-timeline-container').addEventListener('wheel', function (e) {
	//	if (e.shiftKey) console.log("WHEEL+SHIFT")
	//	else console.log("WHEEL")

		if (e.shiftKey) {

			if (e.deltaY < 0) document.getElementById('timeline-bottom-scroll').value++;
			else document.getElementById('timeline-bottom-scroll').value--;
			let event = new CustomEvent("input");
			document.getElementById('timeline-bottom-scroll').dispatchEvent(event);

		}
		else {
			if (e.deltaY < 0) document.getElementById('timeline-side-scroll').value--;
			else document.getElementById('timeline-side-scroll').value++;
			let event = new CustomEvent("input");
			document.getElementById('timeline-side-scroll').dispatchEvent(event);
		}


	});

	//---------------------------------------------- update app to match state -----------------------------------------------

	uxHideOrShowElements(stateUX.activeTab);
	uxShowWorkspaceAfterLoad();

}

//========================================================================================================================================

function handleToolIconClick(e) {
	console.log("handleToolIconClick() " + e)

	selectClick(e); //will call this to handle the active class setting, and other tasks

	let toolIconId = e.getAttribute('id').split('-')[2];
	//console.log(toolIconId);
	let menus = document.getElementById("popout-menu").children; //gets only the children which are the top-level menu containers
	//console.log(menus);

	Array.from(menus).forEach(function (el) {
		if (el.id == `popout-menu-${toolIconId}`) {
			el.classList.replace('visibility-hidden', 'visibility-visible');
		}
		else {
			el.classList.replace('visibility-visible', 'visibility-hidden');
		}
	});

	/*
	document.getElementById("popout-menu").className = 'popout-menu-hidden'; //set current view to hidden
	//will then trigger the 'transitionend' listener to show the newly selected menu
	//attaches a function to run after the CSS transition is completed - only runs once
	//this is suppose to fade down the current menu, and up the previous menu, but doesn't work like that
	document.getElementById("popout-menu").addEventListener("transitionend", function (e) {
	
		console.log("done fading down menu, start fading up new menu " + e);
		document.getElementById("popout-menu").className = 'popout-menu'; //transition it back to opaque
	}, { once: true });
	*/

	//-------------------------- RUN UX ACTIONS WHEN NAVIGATING TO OR FROM -----------------------------

	uxDisableEnabledTools();

	//--------------------------------------------------------------------------------------------------------
}

//========================================================================================================================================d

function uxToolTipAttach(elem, tip, dir) {
	elem.setAttribute('data-tiptext', tip); //TODO LOCALIZATION
	elem.addEventListener('mouseover', function () { uxToolTipShow(this) }); //attach tool tips. done differently since icons do not have an ID
	elem.addEventListener('mouseout', function () { uxToolTipHide() });
	if (dir != undefined) elem.setAttribute("data-tipdir", dir); //up, down, left, right
}

//========================================================================================================================================

// if (DEVELOPMENTFLAG == true) {

document.addEventListener('contextmenu', function (event) {
	let [x, y] = [event.clientX, event.clientY]
	let currentElement = document.elementFromPoint(x, y)
	console.log("Right click on:", currentElement)
});

// }
