"use strict";
//========================================================================================================================================

function layoutNumberOfAdvancedIcons(elem) {
    console.log("layoutNumberOfAdvancedIcons()");
    systemUndoRedoPush('layout');
    if (mainObj.layout.advanced && stateUX.layoutAdvancedPreview) {
        layoutGraphicBuildIcons(); //need to redraw for preview
    }
}

//========================================================================================================================================

function layoutEditDirection(elem) {
    console.log("layoutEditDirection()");
    systemUndoRedoPush('layout');
    if (elem.checked == true) mainObj.layout.shapeDir = "cw";
    else mainObj.layout.shapeDir = "ccw";

    if (mainObj.layout.advanced) {
        if (stateUX.layoutAdvancedPreview) layoutGraphicBuildIcons(); //need to redraw for preview
        //else nothing is done yet.
    }
    else {
        //now in standard mode just draw it
        layoutGraphicIconReset();
        layoutGraphicBuildIcons();
    }
}

//========================================================================================================================================

function layoutNumberOfIcons(elem) {
    console.log("layoutNumberOfIcons()");
    systemUndoRedoPush('layout');
    mainObj.layout.iconAmount = parseInt(elem.value);

    if (mainObj.layout.advanced) {
        if (!stateUX.layoutAdvancedPreview) layoutGraphicIconsRender();
    }
    else {
        //now in standard mode just draw it
        mainObj.layout.centerX = 0; //setting to 0 indicates a reset of positioning
        mainObj.layout.centerY = 0;
        stateUX.shapeCenterEnable = true;
        layoutGraphicIconReset();
        layoutGraphicBuildIcons();
    }
}

//========================================================================================================================================

function layoutEditShape(elem) {
    console.log("layoutEditShape()");
    systemUndoRedoPush('layout');
    mainObj.layout.shape = elem.value;
    uxToolsLayoutUpdate(); //update load file button mostly

    if (mainObj.layout.advanced) {
        if (stateUX.layoutAdvancedPreview) layoutGraphicBuildIcons(); //need to redraw for preview
        //else nothing is done yet. User must preview or add to
    }
    else {
        mainObj.layout.centerX = 0; //setting to 0 indicates a reset of positioning
        mainObj.layout.centerY = 0;
        stateUX.shapeCenterEnable = true;
        layoutGraphicIconReset();
        layoutGraphicBuildIcons();
        pushMessageToLog("New layout shape selected. Please use the center handle to position the shape on the workspace. Press 'Enter' key to confirm placement.")
    }
}

//========================================================================================================================================

function layoutEditIconShape(elem) {
    console.log("layoutEditIconShape()");
    systemUndoRedoPush('layout');

    if (elem.checked == true) mainObj.layout.iconShape = "round";
    else mainObj.layout.iconShape = "square";
    //for both standard and advanced
    layoutGraphicIconClass(); //just need to change the style, not placements
}

//========================================================================================================================================

function layoutEnableAdvanced(elem) {
    console.log("layoutEnableAdvanced()");

    systemUndoRedoPush('layout');
    mainObj.layout.advanced = elem.checked;
    uxToolsLayoutUpdate(); //update add to layout and zone ID

    if (mainObj.layout.advanced) {
        layoutGraphicIconReset(); //just selected advanced clear everything
        //stateUX.zoneView = 0; //PREVIEW ZONE ID
    }
    else {
        //now in standard mode just draw it
        mainObj.layout.centerX = 0; //setting to 0 indicates a reset of positioning
        mainObj.layout.centerY = 0;
        stateUX.shapeCenterEnable = true;
        layoutGraphicIconReset();
        layoutGraphicBuildIcons();
    }
}

//========================================================================================================================================

function layoutEditIconSize(elem) {
    console.log("layoutEditIconSize()");

    systemUndoRedoPush('layout');
    mainObj.layout.iconSize = parseInt(elem.value);

    if (mainObj.layout.advanced) {
        if (stateUX.layoutAdvancedPreview) layoutGraphicBuildIcons(); //need to redraw for preview
        else layoutGraphicIconClass(); //just need to change the style, not coordinates
    }
    else {
        layoutGraphicIconReset();
        layoutGraphicBuildIcons();
    }
}

//========================================================================================================================================

function layoutEditiconDensity(elem) {
    console.log("layoutEditiconDensity()");

    systemUndoRedoPush('layout');
    mainObj.layout.iconDensity = parseInt(elem.value);

    if (mainObj.layout.advanced) {
        if (stateUX.layoutAdvancedPreview) layoutGraphicBuildIcons(); //need to redraw for preview
        //else nothing can be done, coordinates are static
    }
    else {
        layoutGraphicIconReset();
        layoutGraphicBuildIcons();
    }
}

//========================================================================================================================================

function layoutManualPlacementCheckBox(elem) {
    console.log("layoutManualPlacementCheckBox()");
    systemUndoRedoPush('layout');
    stateUX.layoutManualEnable = elem.checked;
    //have to over ride and not use layoutSetZoneView, cause it won't place it cause there are no points so max() doesn't work
    if (stateUX.layoutManualEnable == true)
        stateUX.zoneView = parseInt(document.getElementById('toolmenu-ledicon-zoneval').value); //set the zone view to the current zone ID
    layoutManualPlacementEnable(); //update
}

//========================================================================================================================================

//so it can be used for automatic disable and other uses
function layoutManualPlacementEnable(flag) {
    let theWorkspace = document.getElementById("ws-graphic-container");

    if (flag != undefined) stateUX.layoutManualEnable = flag; //if passed a flag, it is getting set by function
    else stateUX.layoutManualEnable = document.getElementById("toolmenu-ledicon-manplace").checked; //set by user

    document.getElementById("toolmenu-ledicon-manplace").checked = stateUX.layoutManualEnable; //keep state up to date.. here I guess, doesn't matter for user input

    if (stateUX.layoutManualEnable && mainObj.layout.advanced) {
        theWorkspace.addEventListener('mousedown', layoutManualIconPlace);
        theWorkspace.style.cursor = "crosshair";
        layoutGraphicIconsRender(); //changes click/mouse down and stuff. Easiest
    }
    else {
        theWorkspace.removeEventListener('mousedown', layoutManualIconPlace);
        theWorkspace.style.cursor = "";

        if (mainObj.layout.ledIconCoordX != undefined) layoutGraphicIconsRender(); //dumb way, but works. Because of uxDisableEnabledTools() running to soon
    }
    uxToolsLayoutUpdate(); //ensure tools are updated, especially advanced preview is disabled
}

//========================================================================================================================================

function layoutAdvancedPreviewCheckBox(flag) {
    console.log("layoutAdvancedPreviewCheckBox() ", flag);
    let elem = document.getElementById('toolmenu-ledicon-advplace');

    if (flag != undefined) elem.checked = flag;
    else systemUndoRedoPush('layout'); //do not run if a flag is passed, only when user clicks it

    stateUX.layoutAdvancedPreview = elem.checked

    //console.log("++++++++++++++++", stateUX.layoutAdvancedPreview);

    uxToolsLayoutUpdate();
    if (stateUX.layoutAdvancedPreview) {
        mainObj.layout.centerX = 0; //setting to 0 indicates a reset of positioning
        mainObj.layout.centerY = 0;
        stateUX.shapeCenterEnable = true;
        mainObj.layout.rotation = 0;
        uxToolsLayoutUpdate(); //update rotation elements
        layoutGraphicBuildIcons(); //now preview
    }
    else {
        layoutShapeCenterDragEnd();
        layoutGraphicIconsPreviewRender(0, 0, 0); //tricks it to remove the pxPrevSz icons, which were not placed/added
        layoutGraphicIconClass(); //replaced layoutGraphicIconsRender();
    }
}

//========================================================================================================================================

function layoutAdvancedAdd() {
    console.log("layoutAdvancedAdd()");
    stateUX.layoutAdvancedPreview = false;
    document.getElementById("toolmenu-ledicon-advplace").checked = false;     //UPDATE UX - here?

    let theIcons = document.getElementById("ws-graphic-layout-container").querySelectorAll("div.pxPrevSz");
    theIcons.forEach(function (val, index) {
        theIcons[index].remove();
    });

    layoutShapeCenterDragEnd();
    layoutGraphicBuildIcons();     //convert preview to normal, apply zone
}

//========================================================================================================================================

function layoutZoneAssignment(flag) {
    console.log("layoutZoneAssignment() ", flag);
    let elem = document.getElementById("toolmenu-zones-enableassignval");

    if (flag != undefined) stateUX.toolZoneAssign = flag;
    else stateUX.toolZoneAssign = elem.checked;
    elem.checked = stateUX.toolZoneAssign;

    //this is mostly all error handling incase the timeline or graphic has not yet been rendered, or has but is not refreshed
    let icons = document.getElementById("ws-graphic-layout-container");
    let theIcons = []
    theIcons = icons.querySelectorAll("div.pxSz");
    let row = document.getElementById("timeline-right-container");
    let theRows = [];
    if (row != undefined) theRows = row.querySelectorAll("div.timeline-row");
    let rowLabel = document.getElementById("timeline-left-container");
    let theRowLabels = [];
    if (rowLabel != undefined) theRowLabels = rowLabel.querySelectorAll("div.timeline-rowlabel");

    if (stateUX.toolZoneAssign) {
        //need all icons to show cell cursor
        theIcons.forEach(element => element.style.cursor = 'cell'); //force this cursor
        theRows.forEach(element => element.style.cursor = 'not-allowed'); //force this cursor
        theRowLabels.forEach(element => element.style.cursor = 'cell'); //force this cursor
    }
    else {
        theIcons.forEach(element => element.style.removeProperty('cursor')); //reverts to classes default cursor
        theRows.forEach(element => element.style.removeProperty('cursor')); //reverts to classes default cursor
        theRowLabels.forEach(element => element.style.removeProperty('cursor')); //force this cursor
    }
}

//========================================================================================================================================

function layoutZoneMerge() {
    console.log("layoutZoneMerge()");

    systemUndoRedoPush('layout');
    //Merge all pixels in Zone View to the Assigned Zone
    let zoneAssign = parseInt(document.getElementById("toolmenu-zones-assignval").value);
    mainObj.layout.ledIconZoneID.forEach(function (val, index) {
        if (mainObj.layout.ledIconZoneID[index] == stateUX.zoneView) mainObj.layout.ledIconZoneID[index] = zoneAssign;
    });
    layoutGraphicIconsUpdate();
    pushMessageToLog(`All pixels in zone #${stateUX.zoneView} have been merged into zone #${zoneAssign}`);
}

//========================================================================================================================================

function layoutZoneDelete() {
    //console.log("layoutZoneDelete()");
    //  systemUndoRedoPush('layout');
    //let zoneAssign = parseInt(document.getElementById("toolmenu-zones-assignval").value);

    //Not sure what the function should be. 
    //    Either delete all icons and set them to 'deleted' or just splice it out and let higher index shift down
    //    or what?
}

//========================================================================================================================================

function layoutZoneClear() {
    console.log("layoutZoneClear()");

    systemUndoRedoPush('layout');
    layoutSetZoneView(1);
    mainObj.layout.ledIconZoneID.forEach(function (val, index) {
        mainObj.layout.ledIconZoneID[index] = 1;
    });
    layoutGraphicIconsUpdate();
    pushMessageToLog("All zones are moved to zone#1");
}

//========================================================================================================================================

function layoutUpdateBuffers() {
    console.log("layoutUpdateBuffers()");

    if (SelSeq.mode == 'mGradient') {
        //update frame button colors, I guess here....
        let theButtons = document.getElementById('frame-icons-container').querySelectorAll("div");
        theButtons.forEach(function (val, index) {
            getFrameSolid(theButtons[index], 0, index); //easy
        });
    }

    if (stateUX.activeTab == 'navtab-graphic') layoutGraphicIconsUpdate();
    else stateUX.updateGraphic = true; //notify UX to update next time it is viewed
    if (stateUX.activeTab == 'navtab-timeline') layoutTimelineUpdate();
    else stateUX.updateTimeline = true;  //notify UX to update next time it is viewed
}

//========================================================================================================================================

function refreshLayouts(flagEn) {
    console.log("refreshLayouts() with: " + SelSeq.mode + "  tab: " + stateUX.activeTab)
    //console.log(stateUX.refreshGraphic, stateUX.refreshTimeline);

    //---------------- Common -------------------------

    systemVisClassShow("ws-timeline-container");
    systemVisClassHide("ws-pov-container");

    //---------------- Sequence mode specific -------------------------


    switch (SelSeq.mode) {
        case 'mGradient':
            //don't want to do it here and layoutUpdateBuffers() but whatever
            if (SelSeq.mode == 'mGradient') {
                //update frame button colors, I guess here....
                let theButtons = document.getElementById('frame-icons-container').querySelectorAll("div");
                theButtons.forEach(function (val, index) {
                    getFrameSolid(theButtons[index], 0, index);
                });
            }
        case 'mFade':
        case 'mInstant':
            sequenceResetStartValPositions(SelSeq);
        case 'mScene':
            if (stateUX.activeTab == 'navtab-graphic') renderGraphicLayout();
            else if (flagEn != 'disable') stateUX.refreshGraphic = true; //notify UX to update next time it is viewed
            if (stateUX.activeTab == 'navtab-timeline') layoutTimelineRender();
            else if (flagEn != 'disable') stateUX.refreshTimeline = true;  //notify UX to update next time it is viewed
            break;
        case 'mPOV':
            systemVisClassHide("ws-timeline-container");
            systemVisClassShow("ws-pov-container");
            if (stateUX.activeTab == 'navtab-graphic') renderGraphicLayout();
            else if (flagEn != 'disable') stateUX.refreshGraphic = true; //notify UX to update next time it is viewed
            if (stateUX.activeTab == 'navtab-timeline') layoutPOVRender();
            else if (flagEn != 'disable') stateUX.refreshTimeline = true;  //notify UX to update next time it is viewed
            break;
        case 'mFile':
            renderGraphicLayout();
            if (stateUX.activeTab == 'navtab-graphic') renderGraphicLayout();
            else if (flagEn != 'disable') stateUX.refreshGraphic = true; //notify UX to update next time it is viewed
            if (stateUX.activeTab == 'navtab-timeline') layoutFileRender();
            else if (flagEn != 'disable') stateUX.refreshTimeline = true;  //notify UX to update next time it is viewed
            break;
        case 'mList':
            sequenceMeasureAll();
            renderGraphicLayout();
            layoutListRender(); //no other action for now
            break;
        case 'mTechnical':
            //nothing yet
            break;
        default:
            console.log("Sequence mode did not match renderer: " + SelSeq.mode);
            let msg = "<p>&nbsp;&nbsp; Please load a sequence file from  the software tab.<br>&nbsp;&nbsp;&nbsp;Or use the sequence menu in the upper right to create a new sequence.</p>";
            if (stateUX.activeTab == 'navtab-graphic') document.getElementById("ws-graphic-layout-container").innerHTML = msg;
            if (stateUX.activeTab == 'navtab-timeline') document.getElementById("ws-timeline-container").innerHTML = msg;
            break;
    } //end switch
}

//========================================================================================================================================


//new same as getFrameSolid() for now
function setPixelElemColor(cell, pix, frame) {
    // console.log("setPixelElemColor(" + cell + ", " + pix + ", " + frame + ")");
    let mult = getColorModeMult(SelSeq.colorMode); //just makes it shorter name - using as an ID number essentially
    let str;
    let whtStr;
    let index = mult * pix;

    switch (mult) {
        case 1: //Mono
            str = "#" + decToHex(SelSeq.dataFrames[frame][index]) + "" + decToHex(SelSeq.dataFrames[frame][index]) + "" + decToHex(SelSeq.dataFrames[frame][index]);
            break;
        case 4: //RGBW
            whtStr = rgbToHex(SelSeq.dataFrames[frame][index + 3], SelSeq.dataFrames[frame][index + 3], SelSeq.dataFrames[frame][index + 3]);
        case 3: //RGB
            str = "#" + decToHex(SelSeq.dataFrames[frame][index]) + "" + decToHex(SelSeq.dataFrames[frame][index + 1]) + "" + decToHex(SelSeq.dataFrames[frame][index + 2]);
            break;
    }

    //console.log(str, whtStr)
    switch (mult) {
        case 4: //RGBW
            cell.style.backgroundImage = "linear-gradient(180deg, transparent 60%," + whtStr + " 40%)";
        case 1: //Mono
        case 3: //RGB
            cell.style.backgroundColor = str;
            break;
    } //end switch
}



//========================================================================================================================================

function getFrameSolid(cell, pix, frame) {
    //console.log("getFrameSolid(" + cell + ", " + pix + ", " + frame + ")");
    let mult = getColorModeMult(SelSeq.colorMode); //just makes it shorter name - using as an ID number essentially
    let str;
    let whtStr;
    let index = mult * pix;

    switch (mult) {
        case 1: //Mono
            str = "#" + decToHex(SelSeq.dataFrames[frame][index]) + "" + decToHex(SelSeq.dataFrames[frame][index]) + "" + decToHex(SelSeq.dataFrames[frame][index]);
            break;
        case 4: //RGBW
            whtStr = rgbToHex(SelSeq.dataFrames[frame][index + 3], SelSeq.dataFrames[frame][index + 3], SelSeq.dataFrames[frame][index + 3]);
        case 3: //RGB
            str = "#" + decToHex(SelSeq.dataFrames[frame][index]) + "" + decToHex(SelSeq.dataFrames[frame][index + 1]) + "" + decToHex(SelSeq.dataFrames[frame][index + 2]);
            break;
    }

    //console.log(str, whtStr)
    switch (mult) {
        case 4: //RGBW
            cell.style.backgroundImage = "linear-gradient(180deg, transparent 60%," + whtStr + " 40%)";
        case 1: //Mono
        case 3: //RGB
            cell.style.backgroundColor = str;
            // console.log(frame, pix, str)
            break;
    } //end switch
}

//========================================================================================================================================

function getFrameGradient(cell, pix, start, end) {
    //console.log("getFrameGradient(" + pix + ", " + start + ", " + end + ")");
    let mult = getColorModeMult(SelSeq.colorMode); //just makes it shorter name - using as an ID number essentially
    let str, whtStr;
    let index = mult * pix;

    // console.log(mult)

    switch (mult) {
        case 1: //Mono
            str = "#" + decToHex(SelSeq.dataFrames[start][index]) + "" + decToHex(SelSeq.dataFrames[start][index]) + "" + decToHex(SelSeq.dataFrames[start][index])
                + ", #" + decToHex(SelSeq.dataFrames[end][index]) + "" + decToHex(SelSeq.dataFrames[end][index]) + "" + decToHex(SelSeq.dataFrames[end][index]);
            break;
        case 4: //RGBW
            whtStr = rgbToHex(SelSeq.dataFrames[start][index + 3], SelSeq.dataFrames[start][index + 3], SelSeq.dataFrames[start][index + 3]) + "," +
                rgbToHex(SelSeq.dataFrames[end][index + 3], SelSeq.dataFrames[end][index + 3], SelSeq.dataFrames[end][index + 3]);
        case 3: //RGB
            str = "#" + decToHex(SelSeq.dataFrames[start][index]) + "" + decToHex(SelSeq.dataFrames[start][index + 1]) + "" + decToHex(SelSeq.dataFrames[start][index + 2])
                + ", #" + decToHex(SelSeq.dataFrames[end][index]) + "" + decToHex(SelSeq.dataFrames[end][index + 1]) + "" + decToHex(SelSeq.dataFrames[end][index + 2]);
            break;
    } //end switch

    // console.log(str, whtStr)
    switch (mult) {
        case 4: //RGBW
            cell.style.backgroundPosition = "top,bottom";
            cell.style.backgroundSize = "100% 70%,100% 30%";
            cell.style.backgroundRepeat = "no-repeat";
            cell.style.backgroundImage = "linear-gradient(90deg, " + str + "), linear-gradient(90deg," + whtStr + ")";
            break;
        case 1: //Mono
        case 3: //RGB
            cell.style.backgroundImage = "linear-gradient(90deg, " + str + ")";
            break;
    } //end switch
}

//========================================================================================================================================

function setStartValIconColor(elem, pix) {
    let mult = getColorModeMult(SelSeq.colorMode); //just makes it shorter name - using as an ID number essentially
    let index = mult * pix;
    switch (mult) {
        case 1: //Mono
            elem.style.backgroundColor = rgbToHex(SelSeq.startVals[index], SelSeq.startVals[index], SelSeq.startVals[index]);
            break;
        case 4: //RGBW
            //colorWht = rgbToHex(SelSeq.startVals[index + 3], SelSeq.startVals[index + 3], SelSeq.startVals[index + 3]);
            elem.style.backgroundColor = rgbToHex(SelSeq.startVals[index], SelSeq.startVals[index + 1], SelSeq.startVals[index + 2]);
            let white = rgbToHex(SelSeq.startVals[index + 3], SelSeq.startVals[index + 3], SelSeq.startVals[index + 3]);
            elem.style.backgroundImage = "linear-gradient(180deg, transparent 60%," + white + " 40%)";
            break;
        case 3: //RGB
            elem.style.backgroundColor = rgbToHex(SelSeq.startVals[index], SelSeq.startVals[index + 1], SelSeq.startVals[index + 2]);
            break;
    }
}
//========================================================================================================================================

function setStartValIndicatorColor(elem, pix) {
    //console.log("setStartValColor(" + cell + ", " + pix + ", " + start + ")");
    let mult = getColorModeMult(SelSeq.colorMode); //just makes it shorter name - using as an ID number essentially
    let index = mult * pix;
    let color, white;
    switch (mult) {
        case 1: //Mono
            elem.style.borderColor = rgbToHex(SelSeq.startVals[index], SelSeq.startVals[index], SelSeq.startVals[index]);
            break;
        case 4: //RGBW
            //colorWht = rgbToHex(SelSeq.startVals[index + 3], SelSeq.startVals[index + 3], SelSeq.startVals[index + 3]);
            color = rgbToHex(SelSeq.startVals[index], SelSeq.startVals[index + 1], SelSeq.startVals[index + 2]);
            white = rgbToHex(SelSeq.startVals[index + 3], SelSeq.startVals[index + 3], SelSeq.startVals[index + 3]);
            elem.style.borderColor = color + " " + color + " " + white + " " + color;
            elem.style.borderBottomWidth = "4px";
            break;
        case 3: //RGB
            elem.style.borderColor = rgbToHex(SelSeq.startVals[index], SelSeq.startVals[index + 1], SelSeq.startVals[index + 2]);
            break;
    }
}

//========================================================================================================================================

function layoutSetZoneView(val) {
    stateUX.zoneView = val; //set to passed value
    let max = Math.max(...mainObj.layout.ledIconZoneID); //spread operator will check every element or something
    console.log("ran with " + val, stateUX.zoneView, max);
    if (stateUX.zoneView > max) stateUX.zoneView = 0; //wrap back
    else if (stateUX.zoneView < 0) stateUX.zoneView = max; //wrap back
    document.getElementById('toolmenu-zones-viewval').value = stateUX.zoneView; //update ux element
    //layoutGraphicIconsUpdate(); //now update the icons
    //layoutTimelineUpdate(); //update timeline.....
    layoutUpdateBuffers(); //running both causes issues if one does not exist or is outdated(probably)
    if (mainObj.layout.advanced) uxZoneViewLabel();
}

function layoutSetZoneViewStepper(arg, elem) {
    stateUX.zoneView = uxElemNumberStepper(elem, arg);
    layoutSetZoneView(stateUX.zoneView);
}

//========================================================================================================================================

