'use strict';

//================================================================================================

fetch('https://www.nledshop.com/nledaurora/aurora-v3.json')
    .then((response) => {
        return response.json();
    })
    .then((data) => {
        if (data == null) {
            console.log("Aurora Version Check - Unable to retrieve the web file. ", err);
            //No change to the text. leave it default
            let errMsg =
                document.getElementById('ws-software-checksttatus').innerHTML = "Was not able to retrieve<br>update status. Check online."
            pushMessageToLog("Was not able to retrieve update status. Check online.");
        }
        else {
            stateSoftware.updateVer = data;
            console.log("Aurora Version Check - File retrieved.", JSON.stringify(stateSoftware.updateVer));
            console.log(stateSoftware.version, stateSoftware.updateVer);

            if (stateSoftware.version.major < stateSoftware.updateVer.major || stateSoftware.version.minor < stateSoftware.updateVer.minor) {
                document.getElementById('ws-software-checksttatus').innerHTML = "A software update is available.<br>Visit webpage to download"
                uxButtonIndication('ws-software-webpage', true);
                uxButtonIndication('ws-software-checksttatus', true);
                pushMessageToLog("A software update is available. Visit webpage to download");
            }
            else {
                document.getElementById('ws-software-checksttatus').innerHTML = "Software is up to date."
                if (stateSoftware.version.major == stateSoftware.updateVer.major && stateSoftware.version.minor == stateSoftware.updateVer.minor && stateSoftware.updateVer.patch > stateSoftware.version.patch) {

                    document.getElementById('ws-software-checksttatus').innerHTML = "Software has a non-critical update available."
                    uxButtonIndication('ws-software-webpage', true);
                    uxButtonIndication('ws-software-checksttatus', true);
                }
                pushMessageToLog("Web version check success. Software is up to date.");
            }

            if (stateCommunication.connected) {
                systemLoadDevice(); //reload device profile will catch. Does reset the config modules. But that would be rare. User would have to move fast or have really slow internet.
            }
            //else not connected. data is stored to .updateVer, check it when device connects
        }
    });

//================================================================================================

function networkOpenTCP() {
    console.log("networkOpenTCP()");

    //------------------------------------------------------------------------------------------------

    uxHardwareUpdateTCPIP(); //get the IP and port, save it

    //------------------------------------------------------------------------------------------------

    commPrepareToConnect(function () {
        auroraCMD = new AuroraDeviceInterface(); //construct new
        //-----------------------------------------------------------

        let client = new networkBridge;
     //   client.setTimeout(1000); //set timeout if response is not found - only used if server does not respond, not for commands

        client.connect(stateCommunication.networkPort, stateCommunication.networkIP, function () {
            console.log('TCP - Connected');

            auroraCMD.init(client);

            //------------- Redefine methods and variables to generalize with serialport -----------------
            auroraCMD.enableLogging = true;
            auroraCMD.port.isOpen = true;//client.writable; 
            auroraCMD.port.path = stateCommunication.networkIP+":"+stateCommunication.networkPort
            auroraCMD.port.close = function () { //if it isn't a function() it runs when it shouldn't or something
                console.log('TCP - Destroying');
                client.destroy; //doesn't work if add (), why?
                //should go in a 'close' event, but never triggers
                commUXMessage('closed'); //give it a delay for reasons
            }

            //------------------------------------------------------------------------------

            // client.setTimeout(0); //set timeout if response is not found
            commAuroraDeviceConnection();
        });

        auroraCMD.eventTimeout = function () {
            commUXMessage('timeout');
        }


        client.on('data', function (data) {
            // console.log('TCP - Received: ' + data);
            // console.log('TCP - Received: ' +  new TextDecoder().decode(data));
            auroraCMD.receiveData(data);
        });

        client.on('error', function (err) {
            console.log('TCP - error', err);
            commUXMessage('err');
            auroraCMD.port.isOpen = false;
            client.destroy; //doesn't work if add (), why?
        });

        client.on('timeout', function (data) {
            console.log('TCP - timeout');
            commUXMessage('timeout');
            auroraCMD.port.isOpen = false
        });

        client.on('close', function (data) {
            console.log('TCP - close');
            commUXMessage('closed');
            auroraCMD.port.isOpen = false
        });

        client.on('end', function (data) {
            console.log('TCP - end');
            commUXMessage('closed');
            auroraCMD.port.isOpen = false
        });

        //---------------------------------------------------------------------------
    }); //common to serial and TCP and ???

    //-------------------------------------------------------------
}

//================================================================================================
