'use strict';

//========================================================================================================================================



//========================================================================================================================================



//DEBUG
// document.body.oncontextmenu = function () {
//     var x = event.clientX;     // Get the horizontal coordinate
//     var y = event.clientY;     // Get the vertical coordinate
//     console.log("right clicked    X: " + x + "   Y: " + y);
// }

//========================================================================================================================================

//numerous checkboxes will come through here when checked or unchecked
function uxCheckBoxHandler(elem) {
    console.log("uxCheckBoxHandler() ", elem.id + " is set to " + elem.checked);

    switch (elem.id) {
        case "ws-software-disabletips-box":
            if (!elem.checked) {
                console.log("Tooltips disabled");
                stateSoftware.tooltipsEnabled = false;
            }
            else {
                console.log("Tooltips enabled");
                stateSoftware.tooltipsEnabled = true;
            }
            fileSaveSettingsFile();
            break;
        case "ws-connection-enableintensityval":
            document.getElementById('ws-connection-intensity').disabled = !elem.checked;
            mainObj.globalIntensityEnable = elem.checked;
            break;
        case "ws-pov-seqmodecont-usage-enable":
            document.getElementById('ws-pov-seqmodecont-usage-value').disabled = !elem.checked;
            if (elem.checked) SelSeq.povGridSpeed = 1;
            else SelSeq.povGridSpeed = 0;
            document.getElementById('ws-pov-seqmodecont-usage-value').value = SelSeq.povGridSpeed;
            break;
        case 'ws-software-autoconnect-box':
            stateSoftware.autoConnectEnabled = elem.checked;
            fileSaveSettingsFile();
            break;
        case 'ws-software-autoconfigdownload-box':
            stateSoftware.autoDownloadEnabled = elem.checked;
            fileSaveSettingsFile();
            break;
        case 'toolmenu-graphic-grid':
            mainObj.layout.gridEnabled = elem.checked;
            if (mainObj.layout.gridEnabled) document.getElementById("ws-graphic-layout-container").classList.add('bg-grid-100');
            else document.getElementById("ws-graphic-layout-container").classList.remove('bg-grid-100');
            break;
        case 'ws-software-lowperformance-box':
            stateSoftware.lowPerformance = elem.checked;
            fileSaveSettingsFile();
            break;
        case 'ws-software-autoload-box':
            stateSoftware.autoSequencesLoad = elem.checked;
            fileSaveSettingsFile();
            break;
    } //end switch
}

//================================================ Confirm box callbacks ============================================================

function uxLoadSoftwareDemo() {
    console.log("uxLoadSoftwareDemo()");
    systemLoadSequenceFileInit(fileFixPath(path.join(process.cwd(), 'saves/devices/aurora-demonstration-file.auroraseq')), false);
    uxTriggerElementClick('navtab-graphic'); //go to the meat bits
}

function uxResetWindowSize() {
    pushMessageToLog("Reset window size to default of 1024x768. Drag window border to expand size.");
    win.setSize(1024, 768);
}

function uxVisitWebpageDevice() {
    shell.openExternal(stateDevice.soft.url);
}

function uxOpenEULA() {
    //not exactly what I wanted, but good enough
    fetch(path.join(process.cwd(), 'readme.txt')).then((resp) => resp.text()).then(function (textLabelsData) {
        document.getElementById('ovmenu-7-workspace').innerHTML = textLabelsData;
        overlayMenuEvent(event, 'open', 'menu-7');
    });
}

function uxOpenManual() {
    shell.openItem(path.join(process.cwd(), "nled-aurora-manual-v300.pdf"));
}

function uxVisitWebpageAurora() {
    shell.openExternal("https://www.nledshop.com/nledaurora");
}

function uxOpenVideoTutorials() {
    shell.openExternal("https://www.nledshop.com/nledaurora");
}

function uxOpenContactPage() {
    shell.openExternal("https://www.nledshop.com/contact");
}

function uxVisitWebpageUpdates() {
    shell.openExternal("https://www.nledshop.com/deviceupdates");
}

function uxSequenceFileDescriptionUpdate(elem) {
    console.log("uxUpdateSequenceFileDescription()");
    mainObj.description = elem.value;
}

function uxAutoHWPVSwitch(overFlag) {
    console.log("uxAutoHWPVSwitch()");
    let elem = document.getElementById("toolmenu-playback-autohwpvval");
    if (overFlag != undefined) {
        stateCommunication.autoHWPVEnable = overFlag;
        elem.checked = overFlag;
    }
    else stateCommunication.autoHWPVEnable = elem.checked;

    //----------------------------------------------------------------------------
    if (stateCommunication.autoHWPVEnable) {
        stateCommunication.autoHWPVTimer = setInterval(function () {
            if (stateCommunication.timeStamp != stateUX.undoRedoStamp) {
                //console.log("AutoHWPV Ran, Stamp: ", stateCommunication.timeStamp, stateUX.undoRedoStamp);
                stateCommunication.timeStamp = stateUX.undoRedoStamp;
                commUploadHWPV(stateSeq.index);
            }
        }, 1000);
        pushMessageToLog("Starting automatic Hardware Preview. Device will show changes as they are made.");
    }
    else {
        clearInterval(stateCommunication.autoHWPVTimer);
        pushMessageToLog("Ended automatic Hardware Preview.");
    }
}

//========================================================================================================================================

function uxChangeLanguage(elem) {
    stateSoftware.language = elem.options[elem.selectedIndex].getAttribute("data-lang");
    uxTipsAndLabelsUpdate(stateSoftware.language);
    fileSaveSettingsFile();
}

//========================================================================================================================================

function selectTimelineCell(cell) {
    console.log("selectTimelineCell() with " + cell);
    if (stateUX.toolZoneAssign) {
        pushMessageToLog("Can not do action in Zone Assingment mode, see side toolbar. Click the row labels on the left side to apply zone.");
        return;
    }

    let row = parseInt(cell.split('-')[1].replace('r', ''));  //extract the -row(pixel) 
    let frame = parseInt(cell.split('-')[2].replace('c', '')); //and the -cell(frame)

    if (document.getElementById(cell).parentElement.classList.contains('disabled')) return; //rejects click if row is disabled due to zoning

    if (stateUX.toolPaintEnable) {
        handleColorPickerSelection(frame, row, SelSeq.colorMode, 'pixel', stateUX.paintManColor);
        layoutUpdateBuffers();
    }
    else colorPicker.open(event.clientX, event.clientY, SelSeq.colorMode, frame, row, 'pixel');
}

//========================================================================================================================================

function selectTimelineIndicator(indicator) {
    console.log("selectTimelineIndicator() " + indicator.id);
    if (stateUX.toolZoneAssign) {
        pushMessageToLog("Can not do action in Zone Assingment mode, see side toolbar.");
        return;
    }
    systemUndoRedoPush('seq');

    stateUX.indicatorDragging = parseInt(indicator.id.split('-')[1].replace('indicator', ''));//indicator; //save reference to global, since can not pass a parameterr to eventListeners

    // console.log("DEBUG ID", stateUX.indicatorDragging)
    document.addEventListener("mouseup", selectReleaseTimelineIndicator);
    document.addEventListener("mousemove", selectDragTimelineIndicator);
    //indicator.removeAttribute('onmouseout'); //disable mouse out so tip stays showing during dragging
    indicator.removeEventListener('mouseout', window.indicatorMouseout); //disable mouse out so tip stays showing during dragging

    // indicator.classList.add("indicator-trandisable"); //disable transition or dragging is funky
}

//========================================================================================================================================

function selectDragTimelineIndicator(event) {
    // console.log("selectDragTimelineIndicator()", stateUX.indicatorDragging);

    //-------------------------------- Event throttling --------------------------------------------

    stateUX.mouseTimer = setTimeout(function () {
        document.addEventListener("mousemove", selectDragTimelineIndicator)
    }, 25); //static 25mS throttling
    document.removeEventListener("mousemove", selectDragTimelineIndicator);

    //----------------------------------------------------------------------------
    const indicator = document.getElementById("timeline-indicator" + stateUX.indicatorDragging);

    const coords = indicator.parentElement.getBoundingClientRect(); //heard this is really slow......
    const halfW = (indicator.scrollWidth / 2);
    const frameDiv = (1 / SelSeq.frames); //float value of size of each frame
    // console.log(coords)
    // console.log(event.clientX, coords.width)

    if (event.clientX > coords.right) {
        document.getElementById('timeline-bottom-scroll').value++;
        let event = new CustomEvent("input");
        document.getElementById('timeline-bottom-scroll').dispatchEvent(event);
    }
    else if (event.clientX < coords.left) {
        document.getElementById('timeline-bottom-scroll').value--;
        let event = new CustomEvent("input");
        document.getElementById('timeline-bottom-scroll').dispatchEvent(event);
    }

    stateUX.indicatorStep = (coords.width / timelineViewport.cellsWide);
    stateUX.indicatorMax = (coords.width / timelineViewport.cellsWide) * SelSeq.frames;

    //drag
    let newX = (event.clientX - coords.x + (timelineViewport.offsetX * stateUX.indicatorStep)) - halfW;
    if (newX < -halfW) newX = -halfW;
    if (newX > (stateUX.indicatorMax - halfW)) {
        newX = stateUX.indicatorMax - halfW;
    }

    let position = ((newX + halfW) / stateUX.indicatorMax);
    if (position > 1) position = 1; //can this happen anymore?

    let frame = Math.floor(position / frameDiv);
    if (frame < 0) frame = 0; //couldn't happen, probably
    else if (frame >= SelSeq.frames) frame = (SelSeq.frames - 1); //if dragged all the way to the high end
    // console.log("Frame:", frame)
    //-------------------------------------------------------------------------------

    if (cSeqModesStartVals.includes(SelSeq.mode)) {
        //fade,gradient,tech
    }
    else if (SelSeq.mode == 'mInstant') {
        newX = ((stateUX.indicatorMax * frameDiv) * frame) - halfW; //snap to frame start
        position = ((newX + halfW) / stateUX.indicatorMax); //recalc
        if (position > 1) position = 1; //can this happen anymore?
    }

    let pixelID = stateUX.indicatorDragging + timelineViewport.offsetY;
    // console.log(stateUX.indicatorDragging, timelineViewport.offsetY)
    // console.log(newX, position, frame);
    stateSeq.startValPos[pixelID] = position;
    sequenceSetStartValues(SelSeq, pixelID);

    //----------------------------------------------------------------------------

    layoutStartIndicatorPositionSet(stateUX.indicatorDragging, pixelID, stateSeq.startValPos[pixelID]);  //also updates the tool tip

    //----------------------------------------------------------------------------
}

//========================================================================================================================================

function selectReleaseTimelineIndicator() {
    console.log("selectReleaseTimelineIndicator() ");

    //Handle Throttling
    document.removeEventListener("mouseup", selectReleaseTimelineIndicator);
    document.removeEventListener("mousemove", selectDragTimelineIndicator);
    clearTimeout(stateUX.mouseTimer); //prevent mousemove throttling from triggering after release
    stateUX.mouseTimer = null; //used as flag

    //values were placed into state variable during dragging
    stateUX.updateGraphic = true; //update icon colors next time the Graphic tab is viewed

    const indicator = document.getElementById("timeline-indicator" + stateUX.indicatorDragging);
    indicator.removeEventListener('mouseout', function () { if (stateUX.mouseTimer == null) uxToolTipHide() });//renable normal tool-tip style mouseover
    uxToolTipHide(); //close/hide tip if open
    //console.log(indicator.style.left);
    // indicator.classList.remove("indicator-trandisable"); //renable transition, for reset/generate animation
}

//========================================================================================================================================

function selectTimelineRowLabel(rowDiv) {
    console.log("selectTimelineRowLabel() with " + rowDiv);
    let rowNum = parseInt(rowDiv.split('-')[2].replace('rowDiv', ''));

    if (stateUX.toolZoneAssign) {
        let zoneAssign = parseInt(document.getElementById("toolmenu-zones-assignval").value);
        console.log("ASSIGN TO ZONE ", rowNum, zoneAssign);
        mainObj.layout.ledIconZoneID[rowNum] = zoneAssign;
        layoutTimelineUpdate();
    }
    else {
        colorPicker.open(event.clientX, event.clientY, SelSeq.colorMode, 0, rowNum, 'pixelall');
    }
}

//========================================================================================================================================

function selectTimelineFrameLabel(frameDiv) {
    console.log("selectTimelineFrameLabel() with " + frameDiv);
    if (stateUX.toolZoneAssign) {
        pushMessageToLog("Can not select colors while in Zone Assingment mode, see side toolbar.");
        return;
    }
    let frame = parseInt(frameDiv.split('-')[2].replace('frameDiv', ''));
    colorPicker.open(event.clientX, event.clientY, SelSeq.colorMode, frame, 0, 'frameall');
}

//========================================================================================================================================

function selectGraphicPixel(iconNum) {
    console.log("selectGraphicPixel() with " + iconNum);
    if (stateUX.toolZoneAssign) {
        let zoneAssign = parseInt(document.getElementById("toolmenu-zones-assignval").value);
        console.log("ASSIGN TO ZONE ", iconNum, zoneAssign);
        mainObj.layout.ledIconZoneID[iconNum] = zoneAssign;
        layoutGraphicIconsUpdate();
    }
    else {
        if (iconNum < SelSeq.numPixels) {
            colorPicker.open(event.clientX, event.clientY, SelSeq.colorMode, stateSeq.selectedFrame, iconNum, 'pixel');
        }
        //else the icon is not currently enabled, ignore
    }
}

//========================================================================================================================================

function uxPOVDirectionMode(elem) {
    let buttons = document.getElementById("ws-pov-seqmodecont-dirmodebuttoncont").querySelectorAll("button");
    buttons.forEach(function (val, index) {
        buttons[index].classList.remove('active');
    });
    elem.classList.add('active');
    let modeID = elem.id.charAt(elem.id.length - 1) - 1;
    SelSeq.povDirMode = parseInt(modeID);
    sequenceLoadImageAsData(SelSeq.filePath, SelSeq.povDirMode)
}

//========================================================================================================================================

function uxPovGridSpeed(elem) {
    console.log("uxPovGridSpeed()");
    SelSeq.povGridSpeed = parseInt(elem.value);
}

//========================================================================================================================================

function uxPOVElementStates() {
    console.log("uxPOVElementStates()");
    if (SelSeq.povGridSpeed == 0) {
        document.getElementById("ws-pov-seqmodecont-usage-enable").checked = false;
        document.getElementById('ws-pov-seqmodecont-usage-value').disabled = true;
    }
    else {
        if (SelSeq.povGridSpeed <= 0) SelSeq.povGridSpeed = 1;
        document.getElementById("ws-pov-seqmodecont-usage-enable").checked = true;
        document.getElementById('ws-pov-seqmodecont-usage-value').disabled = false;
    }
    document.getElementById('ws-pov-seqmodecont-usage-value').value = SelSeq.povGridSpeed;

    let buttons = document.getElementById("ws-pov-seqmodecont-dirmodebuttoncont").querySelectorAll("button");
    buttons.forEach(function (val, index) {
        buttons[index].classList.remove('active');
    });
    document.getElementById('ws-pov-seqmodecont-button' + (SelSeq.povDirMode + 1)).classList.add('active');
    document.getElementById('ws-pov-seqmodecont-vidimage').checked = SelSeq.povVideoMode;
}

//========================================================================================================================================

function uxHardwareUpdateTCPIP() {
    console.log("uxHardwareUpdateTCPIP()");
    stateCommunication.networkIP = document.getElementById('communication-ipadr-1').value + '.' + document.getElementById('communication-ipadr-2').value + '.' +
        document.getElementById('communication-ipadr-3').value + '.' + document.getElementById('communication-ipadr-4').value;
    stateCommunication.networkPort = document.getElementById('communication-ipport').value;
    fileSaveSettingsFile();
}

//========================================================================================================================================

function selectManualIcon(elem, num) {
    console.log("selectManualIcon() with ", num)
    //console.log(event)

    event.stopPropagation(); //prevents icons from being placed on top of each other

    if (event.which == 1) {
        //left click - grab/move
        elem.style.cursor = 'grabbing';

        stateUX.interactionElem.node = elem; //store for later
        stateUX.interactionElem.num = num; //store for later

        document.addEventListener('mouseup', layoutManualIconDragStop, { once: true });
        document.getElementById("ws-graphic-layout-container").addEventListener('mousemove', layoutManualIconDragging);
    }
    else if (event.which == 3) {
        //right click - delete
        //console.log((mainObj.layout.ledIconCoordX.length - 1), num);

        if ((mainObj.layout.ledIconCoordX.length - 1) == num) {
            let crop = (mainObj.layout.ledIconCoordX.length - 1);
            mainObj.layout.ledIconCoordX.length = crop;
            mainObj.layout.ledIconCoordY.length = crop;
            mainObj.layout.ledIconZoneID.length = crop;
            elem.remove();

            mainObj.layout.iconAmount = mainObj.layout.ledIconCoordX.length; //update iconAmount with the new amount
            uxToolsLayoutUpdate(); //update iconAmount ux element
        }
        else {
            elem.style.visibility = 'hidden'; //elem.remove(); Nope, icons are filled based on DOM order....
            mainObj.layout.ledIconCoordX[num] = 'deleted'; //indicator to fill the index slot next icon place
            mainObj.layout.ledIconCoordY[num] = 'deleted';
        }
    }
}

function layoutManualIconDragStop() {
    console.log("layoutManualIconDragStop()")
    document.getElementById("ws-graphic-layout-container").removeEventListener('mousemove', layoutManualIconDragging);
    stateUX.interactionElem.node.style.cursor = 'grab';
    clearTimeout(stateUX.mouseTimer); //prevent mousemove throttling from triggering after release
}

function layoutManualIconDragging() {
    //throttle mousemove speed
    stateUX.mouseTimer = setTimeout(function () {
        document.getElementById("ws-graphic-layout-container").addEventListener("mousemove", layoutManualIconDragging)
    }, 25);
    document.getElementById("ws-graphic-layout-container").removeEventListener("mousemove", layoutManualIconDragging);

    //console.log("layoutManualIconDragging() " + event)

    mainObj.layout.ledIconCoordX[stateUX.interactionElem.num] = event.clientX - cWSOffsetX;
    mainObj.layout.ledIconCoordY[stateUX.interactionElem.num] = event.clientY - cWSOffsetY;
    stateUX.interactionElem.node.style.left = mainObj.layout.ledIconCoordX[stateUX.interactionElem.num] + 'px';
    stateUX.interactionElem.node.style.top = mainObj.layout.ledIconCoordY[stateUX.interactionElem.num] + 'px';
}

//========================================================================================================================================

function layoutManualIconPlace(event) {
    console.log("layoutManualIconPlace() which: ", event.which);
    event.stopPropagation(); //stop document.body.onclick from running after this function
    if (event.which == 3) return; //right click, no action

    systemUndoRedoPush('layout');

    let zoneID = parseInt(document.getElementById("toolmenu-ledicon-zoneval").value);
    //if (!mainObj.layout.advanced) zoneID = 1; //if advanced is false, ID is always 1 - no longer possible advanced only

    var x = event.clientX;     // Get the horizontal coordinate
    var y = event.clientY;     // Get the vertical coordinate
    //console.log("Clicked to place a point, or move, or delete.  X: " + x + "   Y: " + y);

    x = (x - cWSOffsetX);  //rather than getBounding() etc
    y = (y - cWSOffsetY);
    //Scan up from [0] looking for the first null location. Place coordinate, relative to workspace

    let deletedIcon = mainObj.layout.ledIconCoordX.indexOf('deleted'); //find first index that has the deleted indicator
    if (deletedIcon >= 0) {
        //console.log("place for deleted icon");
        mainObj.layout.ledIconCoordX[deletedIcon] = x; //set coordinates
        mainObj.layout.ledIconCoordY[deletedIcon] = y; //set coordinates
        mainObj.layout.ledIconZoneID[deletedIcon] = zoneID; //set coordinates
    }
    else {
        //can place as many as user wants
        mainObj.layout.ledIconCoordX.push(x); //set coordinates
        mainObj.layout.ledIconCoordY.push(y);
        mainObj.layout.ledIconZoneID.push(zoneID); //set zone
        mainObj.layout.iconAmount = mainObj.layout.ledIconCoordX.length; //update iconAmount with the new amount
        uxToolsLayoutUpdate(); //update iconAmount ux element
    }
    //------------------------------------------------------------
    layoutGraphicIconsRender(); //that seems to be all that is needed

    if (stateUX.zoneView != zoneID) layoutSetZoneView(zoneID); //if not in zone view, enter it
}

//========================================================================================================================================

