"use strict";

//========================================================================================================================================

function ovmSequenceSelectRefresh(contArg) {
    document.getElementById(contArg).innerHTML = ''; //clear container - not the best way to do it

    mainObj.seq.forEach(function (obj, index) {
        ovmSequenceSelectRender(obj, index, contArg); //adds it to the sequence menu
    });
}

//========================================================================================================================================

function ovmSequenceSelectRender(seq, seqIndex, contArg) {
    //console.log("ovmSequenceSelectRender(" + seq + ", " + seqIndex + ")");

    let theDiv = document.getElementById(contArg);
    let theTag; //scratch

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing';
    theTag.id = 'sequence-menu-listing-' + seqIndex; //need this ID since iti s used for getElementbyID()
    theDiv.appendChild(theTag);
    //made the main sequence listing block

    theDiv = theTag; //now target the sequence listing block

    if (contArg.includes('ovmenu-1')) {
        //For sequence select menu
        if (seqIndex == stateSeq.index) theTag.className += " activeSeq"
        //theTag.id = 'sequence-menu-main-' + seqIndex;
        theTag.addEventListener('click', function (e) { sequenceSelect(seqIndex, true); overlayMenuEvent(e, "close"); });
    }
    else if (contArg.includes('ovmenu-5')) {
        //for sequence targeting
        theTag.style.width = '98%';

        //does action for each type of target sequence use
        switch (stateUX.seqTarget) {
            case 'hwpv':
            case 'list':
                if (SelSeq.mode == 'mList' && seq.mode == 'mList') theTag.className = "ovmenu-sequence-listing-disabled"; //list sequences can not contain list
                else theTag.addEventListener('click', function () { targetSequence(seqIndex) });
                break;
            case 'idle':
            case 'indexadd':
            case 'indexreplace':
                theTag.addEventListener('click', function () { targetSequence(seqIndex) });
                break;
        } //end switch
    }

    //main sequence container
    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-main';
    theDiv.appendChild(theTag);
    theDiv = theTag;

    //now main sequence area
    let theRow = document.createElement('div');
    theRow.className = 'ovmenu-sequence-listing-row';
    theDiv.appendChild(theRow);

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-header';
    theTag.innerHTML = '#' + (seqIndex + 1) + ": " + seq.name;
    theRow.appendChild(theTag);

    if (seq.errorFlag == true) {
        let theMsg = document.createElement('span');
        theMsg.style.float = 'right';
        theMsg.style.color = 'red';
        theMsg.style.fontWeight = 'bold';
        theMsg.innerHTML += "&nbsp;&nbsp;&nbsp; Error Detected"
        theTag.appendChild(theMsg);
    }

    theRow = document.createElement('div');
    theRow.className = 'ovmenu-sequence-listing-row2';
    theDiv.appendChild(theRow);

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-thumb';
    theTag.style.backgroundImage = generateThumb(seqIndex, theTag);

    theRow.appendChild(theTag);

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-text';
    theTag.style.whitespace = 'nowrap';
    theTag.innerHTML = "Mode: " + sequenceConvertMode(seq.mode) + "<br>Speed: " + seq.speed + "<br>Memory: " + sequenceMemoryLabel(seq.memory);
    theRow.appendChild(theTag);

    let theWide = document.createElement('div');
    let theTop = document.createElement('div');

    theTop.style.display = 'flex';

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-text';
    theTag.innerHTML = "Color: " + seq.colorMode + "<br>Indexed: " + sequenceIsIndexed(seqIndex);
    theTop.appendChild(theTag);

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-text';
    theTag.innerHTML = "Intensity: " + seq.intensity + "%<br>Play Mode: " + convertPlayModeText(seq.playMode);
    theTop.appendChild(theTag);

    theWide.appendChild(theTop);

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-text';
    if (seq.packetClone != undefined) theTag.innerHTML = "Pixels: " + seq.numPixels + "  (" + seq.numPixels * (seq.packetClone + 1) + " extended)";
    else theTag.innerHTML = "Pixels: " + seq.numPixels;
    theWide.appendChild(theTag);

    theRow.appendChild(theWide);

    //now right side icons area
    if (contArg.includes('ovmenu-1')) {
        theDiv = document.getElementById('sequence-menu-listing-' + seqIndex); //retarget main listing
        theTag = document.createElement('div');
        //theTag.id = 'ovmenu-sequence-icons-' + seqIndex;
        theTag.className = 'ovmenu-sequence-icons'
        theDiv.appendChild(theTag);

        theDiv = theTag;

        theTag = document.createElement('div');
        //theTag.id = 'ux-element-icon-edit-' + seqIndex;
        theTag.className = 'ux-icon-button ux-element-icon-edit ovmenu-sequence-listing-icon'
        theTag.addEventListener('click', function (e) { e.stopPropagation(); seqEditDescriptionMenu() });  //stop click bubbling
        uxToolTipAttach(theTag, 'Edit Sequence Description'); //TODO LOCALIZATION
        theDiv.appendChild(theTag);

        theTag = document.createElement('div');
        //theTag.id = 'ux-element-icon-copy-' + seqIndex;
        theTag.className = 'ux-icon-button ux-element-icon-copy ovmenu-sequence-listing-icon'
        theTag.addEventListener('click', function (e) { e.stopPropagation(); selectConfirmBox("copy-sequence-from-menu", function () { sequenceCopy(seqIndex) }) }); //stop click bubbling
        uxToolTipAttach(theTag, 'Copy Sequence, adds it to the list'); //TODO LOCALIZATION
        theDiv.appendChild(theTag);

        theTag = document.createElement('div');
        //theTag.id = 'ovmenu-sequence-listing-trash-' + seqIndex;
        theTag.className = 'ux-icon-button ux-element-icon-trash ovmenu-sequence-listing-icon'
        theTag.addEventListener('click', function (e) { e.stopPropagation(); selectConfirmBox("delete-sequence-from-menu", function () { sequenceDelete(seqIndex) }) }); //stop click bubbling
        uxToolTipAttach(theTag, 'Delete Sequence'); //TODO LOCALIZATION
        theDiv.appendChild(theTag);
    } //end menu-1 if()
}

//========================================================================================================================================

function generateThumb(seqID, theTag) {
    //console.log("generateThumb() " + seqID, theTag)

    let str = "";
    let whtStr = "";
    let pixMult = getColorModeMult(mainObj.seq[seqID].colorMode);

    //console.log(pixMult, mainObj.seq[seqID].mode, mainObj.seq[seqID].numPixels);

    switch (mainObj.seq[seqID].mode) {
        case 'mFade':
        case 'mGradient':
            for (let i = 0; i < mainObj.seq[seqID].frames; i++) {

                let index = 0;// for now only thumbs Pixel#1
                //if (mainObj.seq[seqID].mode == 'mGradient') index = 0;
                //else index = 0; //pixMult * i;
                if (i > 0) {
                    str += ",";
                    whtStr += ",";
                }
                if (pixMult == 1) str += rgbToHex(mainObj.seq[seqID].dataFrames[i][index], mainObj.seq[seqID].dataFrames[i][index], mainObj.seq[seqID].dataFrames[i][index]); //make it white/greyscale
                else {
                    //console.log(mainObj.seq[seqID].dataFrames[i])
                    str += rgbToHex(mainObj.seq[seqID].dataFrames[i][index], mainObj.seq[seqID].dataFrames[i][index + 1], mainObj.seq[seqID].dataFrames[i][index + 2]); //RGB
                    if (pixMult == 4) whtStr += rgbToHex(mainObj.seq[seqID].dataFrames[i][index + 3], mainObj.seq[seqID].dataFrames[i][index + 3], mainObj.seq[seqID].dataFrames[i][index + 3]); //RGBW
                }
            } //end for()
            //what to do if RGBW - add a stripe or something
            str += "," + str.substring(0, 7); //RGB section
            whtStr += "," + whtStr.substring(0, 7);//white section
            break;

        case 'mInstant':
        case 'mFile':
        case 'mScene':
            let size = 100 / mainObj.seq[seqID].frames; //used for the hard-stop effect with linear-gradients
            let sizeCount = 0; //tracks
            for (let i = 0; i < mainObj.seq[seqID].frames; i++) {
                let index = 0;//only thumb pixel#1
                if (i > 0) {
                    str += ",";
                    whtStr += ",";
                }
                if (pixMult == 1) str += rgbToHex(mainObj.seq[seqID].dataFrames[index], mainObj.seq[seqID].dataFrames[index], mainObj.seq[seqID].dataFrames[index]); //make it white/greyscale
                else {
                    str += rgbToHex(mainObj.seq[seqID].dataFrames[i][index], mainObj.seq[seqID].dataFrames[i][index + 1], mainObj.seq[seqID].dataFrames[i][index + 2]); //RGB
                    if (pixMult == 4) whtStr += rgbToHex(mainObj.seq[seqID].dataFrames[i][index + 3], mainObj.seq[seqID].dataFrames[i][index + 3], mainObj.seq[seqID].dataFrames[i][index + 3]); //RGBW
                }
                str += " " + +size + "% " + (sizeCount + size) + "%"; //RGB section
                whtStr += " " + +size + "% " + (sizeCount + size) + "%"; //white section
                sizeCount += size;
            } //end for()
            break;

        case 'mPOV':
            //draw image
            theTag.style.backgroundPosition = "center";
            theTag.style.backgroundRepeat = "no-repeat";

            if (mainObj.seq[seqID].filePath == 'none' || mainObj.seq[seqID].filePath == undefined || mainObj.seq[seqID].filePath == null || !fs.existsSync(mainObj.seq[seqID].filePath)) {
                //used for generic icon - backup
                theTag.style.backgroundSize = "75%, 100%";
                return "url(assets/svgs/eye.svg),radial-gradient(red, green, blue)";
            }
            else {
                //loads the image as the icon - preferred
                theTag.style.backgroundSize = "cover"; //original
                return 'url("' + mainObj.seq[seqID].filePath + '")';
            }
        case 'mList':
            theTag.style.backgroundPosition = "center";
            theTag.style.backgroundRepeat = "no-repeat";
            theTag.style.backgroundSize = "75%, 100%";
            return "url(assets/svgs/list-ol-wht.svg),radial-gradient(red, green, blue)";

            /*
            //slice first 4 sequences and generate independantly...... abandoned for something more simple
            console.log("LIST=========================================================================");
            console.log(mainObj.seq[seqID].frames)

            let slicePerc;
            if (mainObj.seq[seqID].frames > 4) slicePerc = (100 / 4); //yes it is always 25%.....
            else slicePerc = Math.floor(100 / mainObj.seq[seqID].frames);
            theTag.style.backgroundPosition = "";
            theTag.style.backgroundSize = "";
            theTag.style.backgroundRepeat = "no-repeat";
            //mainObj.seq[seqID].frames
            for (let i = 0; i < 4; i++) {
                console.log("THIS: "+i)
                str += "," + generateThumb(2, theTag);
                theTag.style.backgroundPosition += "top,";
                theTag.style.backgroundSize += "100%  " + slicePerc * (i + 1) + "%,";
            }
            theTag.style.backgroundSize += "50% 100%";
            //add arrow
            console.log(str)
            return str;
            */

            break;
        case 'mTechnical':
            //NO IDEA
            break;
        default:
            //ERROR
            break;
    } //end switch

    //console.log(str)
    if (pixMult == 4) {
        theTag.style.backgroundPosition = "top,bottom";
        theTag.style.backgroundSize = "100% 70%,100% 30%";
        theTag.style.backgroundRepeat = "no-repeat";
        return "linear-gradient(90deg, " + str + "), linear-gradient(90deg," + whtStr + ")";
    }
    else {
        return "linear-gradient(90deg, " + str + ")";
    }
}

//========================================================================================================================================

function indexRefresh() {
    console.log("indexRefresh()");

    indexMemoryGaugeRefresh(); //always needs to run if this function does

    var div = document.getElementById('ws-connection-index-container');
    while (div.firstChild) {     //supposedly the correct method
        div.removeChild(div.firstChild);
    }

    uxToolTipHide(); //if the user deleted the only sequence, the tool tip for the delete icon will still show on top, since it can't mouseout

    if (mainObj.userIndex.length > 0) {
        mainObj.userIndex.forEach(function (val, index) {
            indexRender(val, index); //adds it to the sequence menu
        });
    }

    //----------------------- now add the bottom "Add Sequence" button ---------------------------------------

    let theDiv = document.getElementById("ws-connection-index-container");
    let theTag; //scratch

    theTag = document.createElement('div');
    theTag.classList = 'seqindex-addlisting';
    theTag.id = 'seqindex-addtile-last'
    theTag.innerText = 'Add A Sequence'
    theTag.addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-5', 'indexadd'); stateUX.slotTarget = (mainObj.userIndex.length + 1) });
    theDiv.appendChild(theTag);
}

//========================================================================================================================================

function indexRender(seqID, index) {
    //console.log("indexRender(" + seqID + ", " + index + ")");
    //console.log(mainObj.userIndex);

    let theDiv;// = document.getElementById("ws-connection-index-container");
    let theTag; //scratch

    //-------------------------------- Draw add button --------------------------------

    theDiv = document.getElementById('ws-connection-index-container');

    theTag = document.createElement('div');
    theTag.classList = 'seqindex-addlisting';
    theTag.id = 'seqindex-addtile-' + index
    theTag.innerText = 'Add A Sequence'
    theTag.addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-5', 'indexadd'); stateUX.slotTarget = index; });
    theDiv.appendChild(theTag);
    //made the main sequence listing block

    //-------------------------------- Draw sequence tile --------------------------------

    theTag = document.createElement('div');
    theTag.classList = 'seqindex-listing';
    theTag.id = 'connection-seqindex-listing-' + index;
    theDiv.appendChild(theTag);
    //made the main sequence listing block

    //theTag.setAttribute('onclick', 'connectionIndexDrag(this)');

    theTag.addEventListener('dragover', function (event) {
        event.preventDefault(); //required for it all to work
        this.classList.add("ws-connection-indexlisting-draghover");
    });

    theTag.addEventListener('dragenter', function () {
        //console.log("ENTER"+event.target.id);
    });

    theTag.addEventListener('dragstart', function (event) {
        //console.log("START" + event.target.id)
        event.dataTransfer.setData("text", event.target.id);
    });

    theTag.addEventListener('dragleave', function () {
        //console.log("END" + event.target.id)
        this.classList.remove("ws-connection-indexlisting-draghover");
    });

    /*
    theTag.ondragend = function () {
        console.log("END");
        event.preventDefault();
        let data = event.path[0].id;
        console.log(data)
        let dragID = mainObj.userIndex[parseInt(data.split("-")[3])];
        console.log(dragID)
        mainObj.userIndex.splice(dragID, 1); //insert
        indexRefresh();
    };
    */

    theTag.addEventListener('drop', function (event) {
        event.preventDefault();
        let slot = parseInt(event.target.parentNode.id.split("-")[3]);
        let dragID = parseInt(event.dataTransfer.getData("text").split("-")[3]);
        let hold = mainObj.userIndex[dragID];

        if (Number.isNaN(slot)) {
            console.log("drag and dropped onto copy/trash icon, which causes a bug. Drop ignored");
            return; //leave since there was an error
        }

        console.log("DROPPED - From Slot#" + dragID + "   Into Slot#" + slot);
        mainObj.userIndex[dragID] = mainObj.userIndex[slot];
        mainObj.userIndex[slot] = hold;
        indexCalculateMemory();
        indexRefresh();
    });

    theTag.setAttribute('draggable', true);

    theDiv = theTag; //now target the sequence listing block

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-thumb';
    theTag.className += ' seqindex-thumb'; //will have to calculate how many digits and adjust class to suit so it doesn't overflow
    theTag.innerHTML = '#' + (index + 1);
    theTag.style.backgroundImage = generateThumb(seqID, theTag);

    theDiv.appendChild(theTag);;

    theTag = document.createElement('div');
    theTag.className = 'seqindex-listing-text';
    theTag.innerHTML = mainObj.seq[seqID].name +
        "<br>Color: " + mainObj.seq[seqID].colorMode +
        " &nbsp; &nbsp; &nbsp; &nbsp; " + sequenceConvertMode(mainObj.seq[seqID].mode) +
        "<br>Memory: " + sequenceMemoryLabel(mainObj.seq[seqID].memory) +
        " &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;Speed: " + mainObj.seq[seqID].speed;
    theDiv.appendChild(theTag);;

    //-------------------------------- Drew sequence tile, Add Icons  --------------------------------

    theTag = document.createElement('div');
    theDiv.appendChild(theTag);
    theDiv = theTag; //now target the sequence listing block

    theDiv.style.flexDirection = 'column';
    theDiv.style.display = 'flex';
    theDiv.style.alignItems ='end'



   let theDivRow  = document.createElement('div');
//    theDivRow.style.flexDirection = 'column';
   theDivRow.style.display = 'flex';
// console.log(mainObj.seq);

    theTag = document.createElement('div');
    theTag.className = 'ux-icon-button ux-element-icon-edit seqindex-listing-icons'
    theTag.addEventListener('click', function () {  document.getElementById("navtab-timeline").click();sequenceSelect(seqID, true) });
    uxToolTipAttach(theTag, 'Edit Sequence'); //TODO LOCALIZATION
   // theDiv.appendChild(theTag);
   theDivRow.appendChild(theTag);



    theTag = document.createElement('div');
    theTag.className = 'ux-icon-button ux-element-icon-link seqindex-listing-icons'
    theTag.addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-5', 'indexreplace'); stateUX.slotTarget = index; });
    theTag.style.margin = '5px;'
    uxToolTipAttach(theTag, 'Link sequence to index slot'); //TODO LOCALIZATION
   // theDiv.appendChild(theTag);
   theDivRow.appendChild(theTag);

   theDiv.appendChild(theDivRow);

    theTag = document.createElement('div');
    theTag.className = 'ux-icon-button ux-element-icon-trash seqindex-listing-icons'
    theTag.addEventListener('click', function () { indexDeleteTile(index) });
    uxToolTipAttach(theTag, 'Remove Sequence From Index'); //TODO LOCALIZATION
    theDiv.appendChild(theTag);
}

//========================================================================================================================================

function renderIdleSequenceTile(seqID) {
    console.log("renderIdleSequenceTile()");

    let theDiv = document.getElementById('ws-connection-idleseqtile');
    try {
        renderCommonSequenceTile(theDiv, seqID, false);
    }
    catch (e) {
        theDiv.innerHTML = "Please click here to select." //LOCALIZATION
    }
}

//========================================================================================================================================

function renderCommonSequenceTile(theDiv, seqID, flag = true) {
    let theTag; //scratch

    theDiv.innerHTML = ''; //clear container - not the best way to do it

    //-------------------------------- Draw sequence tile --------------------------------

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-thumb';
    theTag.className += ' seqindex-thumb'; //will have to calculate how many digits and adjust class to suit so it doesn't overflow
    if (flag) theTag.innerHTML = '#' + (seqID + 1)

    theTag.style.backgroundImage = generateThumb(seqID, theTag);
    theDiv.appendChild(theTag);


    let theBlock = document.createElement('div');
    theBlock.style.width = "75%";
    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-condensed-text';
    theTag.innerText = mainObj.seq[seqID].name;
    theBlock.appendChild(theTag);

    let theRow = document.createElement('div');
    theRow.style.display = 'flex';
    theRow.style.justifyContent = 'space-between';
    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-condensed-text';
    theTag.innerText = "Mode: " + sequenceConvertMode(mainObj.seq[seqID].mode);
    theRow.appendChild(theTag);

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-condensed-text';
    theTag.innerText = mainObj.seq[seqID].colorMode;
    theRow.appendChild(theTag);

    //theTag = document.createElement('div');
    //theTag.className = 'ovmenu-sequence-listing-condensed-text';
    //theTag.innerText = "Speed: " + mainObj.seq[seqID].speed;
    //theRow.appendChild(theTag);

    theBlock.appendChild(theRow);

    theTag = document.createElement('div');
    theTag.className = 'ovmenu-sequence-listing-condensed-text';
    theTag.innerHTML = "Memory: " + sequenceMemoryLabel(mainObj.seq[seqID].memory);
    theBlock.appendChild(theTag);

    theDiv.appendChild(theBlock);
}

//========================================================================================================================================

function ovmLiveControlRefresh() {
    console.log("ovmLiveControlRefresh()");
    //where to send the live mode command?
    let cont = document.getElementById('ovmenu-2-workspace');
    let theTag; //scratch
    let theDiv; //scratch

    //--------------------------------clear the DIV, rather than innerHTML --------------------------------

    while (cont.firstChild) cont.removeChild(cont.firstChild);

    //----------------------------------------------------------------------------------------

    //should fill sliders and background colors of rects. And a clear button

    //----------------------------------------------------------------------------------------

    let numOfPixElem = document.getElementById('ovmenu-2-numofpix');
    let viewMode = ovmLiveControlViewMode();
    let colorMult = ovmLiveControlColorMult(viewMode);

    //---------------------------- Clamp Number of Pixels -----------------------------------

    let numOfPix = parseInt(numOfPixElem.value);
    //if (numOfPix > numOfPixElem.maxVal) numOfPix = numOfPixElem.maxVal;
    //else if (numOfPix < numOfPixElem.minVal) numOfPix = numOfPixElem.minVal;

    //console.log(colorMult, viewMode);
    //---------------------------- Handler Per Mode Rendering -----------------------------------

    switch (viewMode) {
        case 'slidersRGB':
        case 'slidersMono':
            for (let i = 0; i < numOfPix; i++) {
                theDiv = document.createElement('div');
                theDiv.innerText = (i + 1) + ': ';
                theDiv.className = 'liveControlSliderLine'
                cont.appendChild(theDiv);

                theTag = document.createElement('input');

                //choose class based on color mode
                if (viewMode == 'slidersMono') theTag.className = 'ux-sliders liveControlMonoSlider';
                else theTag.className = 'ux-sliders liveControlRGBSlider';

                //all white
                theTag.style.backgroundColor = `rgb(${stateCommunication.liveControlPacket[i]},${stateCommunication.liveControlPacket[i]},${stateCommunication.liveControlPacket[i]})`;

                theTag.setAttribute('type', 'range');
                theTag.value = 0;
                theTag.max = 255;
                theTag.addEventListener('input', function () { ovmLiveControlSliderRefresh(this, i) });
                theDiv.appendChild(theTag);
            }
            break;
        case 'slidersRGBW':
            theDiv = document.createElement('div');
            theDiv.innerText = 'RGBW Sliders not implemented yet, use Sliders, Mono or Icon, RGBW';
            cont.appendChild(theDiv);
            break;
        case 'iconsMono':
        case 'iconsRGB':
        case 'iconsRGBW':
            for (let i = 0; i < numOfPix; i++) {
                theDiv = document.createElement('div');
                theDiv.className = 'liveControlIcon';
                theDiv.innerText = (i + 1);

                //fill color from state array
                switch (viewMode) {
                    case 'iconsMono':
                        theTag.style.backgroundColor = `rgb(${stateCommunication.liveControlPacket[i]},${stateCommunication.liveControlPacket[i]},${stateCommunication.liveControlPacket[i]})`;
                        break;
                    case 'iconsRGB':
                        theDiv.style.backgroundColor = `rgb(${stateCommunication.liveControlPacket[(i * 3)]},${stateCommunication.liveControlPacket[(i * 3) + 1]},${stateCommunication.liveControlPacket[(i * 3) + 2]})`;
                        break;
                    case 'iconsRGBW':
                        theDiv.style.backgroundColor = `rgb(${stateCommunication.liveControlPacket[(i * 4)]},${stateCommunication.liveControlPacket[(i * 4) + 1]},${stateCommunication.liveControlPacket[(i * 4) + 2]})`;
                        theDiv.style.backgroundImage =
                            `linear-gradient(180deg, transparent 60%, ${rgbToHex(stateCommunication.liveControlPacket[(i * 4) + 3], stateCommunication.liveControlPacket[(i * 4) + 3], stateCommunication.liveControlPacket[(i * 4) + 3])} 40%)`;
                        break;
                }

                theDiv.addEventListener('click', function () { ovmLiveControlIconSelect(this, i) })
                cont.appendChild(theDiv);
            }
            break;
        default:
            theDiv = document.createElement('div');
            theDiv.innerText = 'Not implemented yet, use Sliders';
            cont.appendChild(theDiv);
            break;
    } //end switch
}

//========================================================================================================================================

function ovmGammaRender() {
    console.log("ovmGammaRender()");

    let theCont = document.getElementById("ovmenu-4-workspace");
    let theMain;
    let theTag;
    let theRight;
    let theTop;
    let theBottom;

    theCont.innerHTML = ''; //clear container

    //stateDevice.soft.gammaMode
    //gammaMode 2 only - will need different for other ones..... which are currently not supported
    //---------------------------------------------------------------

    if (stateDevice.soft.gammaMode == 2) {
        document.getElementById("ovmenu-4-con-upload").removeAttribute('disabled');
        document.getElementById("ovmenu-4-con-description").innerHTML = "Showing Gamma Settings For:<br> " + stateDevice.soft.name;

        if (gammaTables.red.length == 0) gammaTables.red = cDefaultGammaTable;
        if (gammaTables.green.length == 0) gammaTables.green = cDefaultGammaTable;
        if (gammaTables.blue.length == 0) gammaTables.blue = cDefaultGammaTable;
        if (gammaTables.white.length == 0) gammaTables.white = cDefaultGammaTable;

        //---------------------------------------------------------------

        //Build interface
        helper('red');
        helper('green');
        helper('blue');
        helper('white');

        //Populate the graph with data
        populate('red', gammaTables.red);
        populate('green', gammaTables.green);
        populate('blue', gammaTables.blue);
        populate('white', gammaTables.white);
    }
    else if (stateDevice.soft.gammaMode == 1) {
        document.getElementById("ovmenu-4-con-upload").setAttribute('disabled', true);
        theCont.innerHTML = "<b>This device's gamma settings are not configurable.</b>";
    }
    else {
        document.getElementById("ovmenu-4-con-upload").setAttribute('disabled', true);
        if (stateDevice.soft.gammaMode == undefined) theCont.innerHTML = "<b>No NLED device is connected. Please connect a device to view the gamma correciton settings.</b>";
        else if (stateDevice.soft.gammaMode != 2) theCont.innerHTML = "<b>The software does not yet support the connected device's gamma mode. Will be implemented in the future.</b>";
    }

    //---------------------------------------------------------------

    function populate(color, buf) {
        let graphCont = document.getElementById('ovmenu-4-table-graph-' + color);
        //console.log(graphCont);

        let y = 0;
        let scale = 100 / 256;//container is square
        //100 percent divided by 8-bit(256)

        for (let x = 0; x < 256; x++) {
            let point = document.createElement('div');
            //point.id = "p" + x; // don't need to reference ever
            point.className = 'ovmenu-4-workspace-point';
            point.style.left = Math.round((x * scale) * 10) / 10 + "%"; //static - rounded to nearest 0.1%
            point.style.bottom = Math.round((buf[y++] * scale) * 10) / 10 + "%"; //user specified - rounded to nearest 0.1%
            graphCont.appendChild(point);
        }
    }

    //---------------------------------------------------------------

    function helper(color) {
        //-----------------------------------

        theMain = document.createElement('div');
        theMain.className = 'ovmenu-4-table-container';
        theCont.appendChild(theMain);

        //-----------------------------------

        theTop = document.createElement('div');
        theTop.className = 'flexBasic';//'ovmenu-4-table-top';
        theMain.appendChild(theTop);

        //-----------------------------------

        theTag = document.createElement('div');
        theTag.className = 'ovmenu-4-table-ylabel';
        theTag.innerHTML = "100% &nbsp&nbsp&nbsp&nbsp&nbsp Intensity &nbsp&nbsp&nbsp&nbsp&nbsp0%";
        theTop.appendChild(theTag);

        //-----------------------------------

        theRight = document.createElement('div');
        theTop.appendChild(theRight);

        //-----------------------------------

        theTag = document.createElement('div');
        theTag.classList = 'textCenter fontBold';//'ovmenu-4-table-toplabel';
        theTag.textContent = color.toUpperCase();
        theRight.appendChild(theTag);

        //-----------------------------------

        theTag = document.createElement('div');
        theTag.id = 'ovmenu-4-table-graph-' + color;
        theTag.className = 'ovmenu-4-table-graph';
        theRight.appendChild(theTag);

        //-----------------------------------

        theTag = document.createElement('div');
        theTag.className = 'ovmenu-4-table-xlabel';
        theTag.innerHTML = "0&nbsp &nbsp&nbsp&nbspLinear Value &nbsp&nbsp&nbsp 256";
        theRight.appendChild(theTag);

        //-----------------------------------

        theBottom = document.createElement('div');
        theBottom.className = 'textCenter';//'ovmenu-4-table-bottom';
        theMain.appendChild(theBottom);

        theTag = document.createElement('button');
        theTag.classList = "ux-buttons buttonstyle";
        theTag.style.margin = "15px";
        theTag.textContent = "Load Default Table"
        theTag.addEventListener('click', function () { uxTabLoadDefaultGamma(color); })
        uxToolTipAttach(theTag, 'Loads the default gamma table into the color table. Does not upload.') //TODO LOCALIZATION
        theBottom.appendChild(theTag);

        theTag = document.createElement('button');
        theTag.classList = "ux-buttons buttonstyle";
        theTag.addEventListener('click', function () { fileLoadUserGammaFile(color); });
        uxToolTipAttach(theTag, 'Opens file dialog for user to select a gamma file to load into the color table. Does not upload.') //TODO LOCALIZATION
        theTag.textContent = "Load Custom Table"
        theBottom.appendChild(theTag);

        //-----------------------------------
    }
}

//========================================================================================================================================

