'use strict';

var timelineViewport = {
    offsetX: 0,
    offsetY: 0,
    cellsWide: 0,
    cellsHigh: 0
}


//========================================================================================================================================

//applies the data colors
function layoutTimelineUpdate() {
    console.log("layoutTimelineUpdate() " + SelSeq.mode);
    if (SelSeq.mode == 'mList' || SelSeq.mode == 'mPOV') return;

    let nextFrame;
    //removes all of the disable if out of zone view - will add them again if required. easiest...
    document.querySelectorAll(".tl-row-hiddentext").forEach(e => e.parentNode.removeChild(e));

    let pixelOffset = timelineViewport.offsetY + timelineViewport.cellsHigh;
    if (pixelOffset > SelSeq.numPixels) {
        console.log("over pixel limit")
        pixelOffset = SelSeq.numPixels;
    }

    let frameOffset = timelineViewport.offsetX + timelineViewport.cellsWide;
    if (frameOffset > SelSeq.frames) {
        console.log("over frames limit")
        frameOffset = SelSeq.frames;
    }

    let frameNum = 0;
    let pixelID = 0;

    for (let i = timelineViewport.offsetY; i < pixelOffset; i++) {


        if (mainObj.layout.advanced) {
            if (stateUX.zoneView == 0 || mainObj.layout.ledIconZoneID[pixelID] == stateUX.zoneView || mainObj.layout.ledIconZoneID[pixelID] == undefined) {
                if (mainObj.layout.ledIconZoneID[pixelID] == undefined) document.getElementById('timeline-rowlabel-' + pixelID).classList.add("nozone");
                document.getElementById('tl-row-' + pixelID).classList.remove("disabled"); //make sure it is enabled
            }
            else {
                let theTag = document.createElement('div');
                theTag.className = 'tl-row-hiddentext';
                theTag.innerText = "Hidden by Zone View";
                document.getElementById('tl-row-' + pixelID).prepend(theTag);
                document.getElementById('tl-row-' + pixelID).classList.add("disabled");
                //can still click the cells, but whatever
            }
        }
        else {
            document.getElementById('tl-row-' + pixelID).classList.remove("disabled"); //in case - will error if timeline hasn't been generatedyet
        }

        //-------------------------------------------------------------------

        for (let q = timelineViewport.offsetX; q < frameOffset; q++) { // SelSeq.frame
            let elem = document.getElementById('tl-r' + pixelID + '-c' + frameNum);

            if ((q + 1) == SelSeq.frames) nextFrame = 0; //wrap to first frame
            else nextFrame = (q + 1); //target next frame

            //console.log( i, q)
            switch (SelSeq.mode) {
                case 'mFade':
                    getFrameGradient(elem, i, q, nextFrame);
                    break;
                case 'mGradient':
                    getFrameGradient(elem, 0, q, nextFrame); //pix is always 0, since all use the same values
                    break;
                case 'mFile':
                case 'mScene':
                case 'mInstant':
                    getFrameSolid(elem, i, q);
                    break;
                default:
                case 'mPOV':
                case 'mList':
                case 'mTechnical':
                    console.log("A major error occured, this should not happen");
                    break;
            } //end switch

            frameNum++;
        } //end q for()
        //layoutStartIndicatorPlace(i)

        frameNum = 0;
        pixelID++;
    }//end i for()

    //---------------------------------------------------------------------------------------

    for (let i = 0; i < timelineViewport.cellsHigh; i++) {
        document.getElementById('tl-rlab-' + i).innerHTML = "Pix" + (Number(i) + Number(timelineViewport.offsetY) + 1);
        // console.log(i + timelineViewport.offsetY + 1, SelSeq.numPixels)
        if ((i + timelineViewport.offsetY + 1) > SelSeq.numPixels) {
            console.log("OVER, cellsHigh");
        }
    }

    if (SelSeq.mode == 'mScene') {
        document.getElementById("tl-fbtn-0").innerHTML = "Scene";
    }
    else {

        for (let i = 0; i < timelineViewport.cellsWide; i++) {
            if (i >= SelSeq.frames) break;
            // document.getElementById('tl-fbtn-' + i).innerHTML = "F" + (Number(i) + Number(timelineViewport.offsetX) + 1);
            document.getElementById('tl-fbtn-' + i).innerHTML = (Number(i) + Number(timelineViewport.offsetX) + 1);
            // document.getElementById('tl-fbtn-' + i).style.fontSize = "12px";

            if ((i + timelineViewport.offsetX + 1) > SelSeq.frames) {
                console.log("OVER, cellsWide");
            }
        }
    }
    layoutTimelineIndicatorUpdate(SelSeq, timelineViewport.offsetY, (timelineViewport.offsetY + timelineViewport.cellsHigh)); //now position the start indicators. stateSeq.startValPos must be updated
}


//========================================================================================================================================

function layoutTimelineRender() {
    console.log("layoutTimelineRender() " + SelSeq.name + ", " + SelSeq.frames);

    stateUX.refreshTimeline = false; //clear UX state notification


    //reset timeline viewport
    timelineViewport.offsetX = 0;
    timelineViewport.offsetY = 0;
    timelineViewport.cellsWide = 0;
    timelineViewport.cellsHigh = 0;

    //-----------------------------------------------------------------------------------------
    let workspace = document.getElementById("ws-timeline-container");
    workspace.innerHTML = "";
    workspace.style.display = "flex";
    workspace.style.overflow = "hidden";

    //-----------------------------------------------------------------------------------------
    let sidebar = document.createElement('div');
    sidebar.id = 'timeline-sidebar';
    workspace.prepend(sidebar);

    //-----------------------------------------------------------------------------------------

    let centDiv = document.createElement('div');


    let header = document.createElement('div');
    header.id = 'timeline-header';
    centDiv.prepend(header);


    let workContainer = document.createElement('div');
    workContainer.id = 'timeline-row-container';
    centDiv.appendChild(workContainer);


    let bottomScroller = document.createElement('input');
    bottomScroller.type = "range";
    bottomScroller.value = "0";
    bottomScroller.min = "0";
    bottomScroller.id = 'timeline-bottom-scroll';
    bottomScroller.classList = "ux-scrollbarsliders";
    centDiv.appendChild(bottomScroller);

    workspace.appendChild(centDiv);

    //-----------------------------------------------------------------------------------------

    const workspaceCoords = workContainer.getBoundingClientRect();


    let magicWidth = 60; //in pixels
    let magicHeight = 35; //in pixels, with bottom padding
    if (SelSeq.mode == 'mFile') magicWidth = 30;

    timelineViewport.cellsWide = Math.floor(workspaceCoords.width / magicWidth); //MAGIC NUMBER
    if (SelSeq.frames < timelineViewport.cellsWide) timelineViewport.cellsWide = SelSeq.frames; //expand cells if there is room


    timelineViewport.cellsHigh = Math.floor(workspaceCoords.height / magicHeight);  //MAGIC NUMBER height of cell, 5 margin
    if (timelineViewport.cellsHigh > SelSeq.numPixels) timelineViewport.cellsHigh = SelSeq.numPixels;
    bottomScroller.max = SelSeq.frames - timelineViewport.cellsWide; //number of frames minus columns in viewport


    for (let i = 0; i < timelineViewport.cellsWide; i++) {

        let theTag = document.createElement('div');
        theTag.id = 'tl-fbtn-' + i;
        theTag.idNum = i;
        theTag.classList = 'timeline-fbtn';
        if (i >= SelSeq.frames) {
            theTag.classList.add('hide');
        }
        theTag.innerHTML = "F" + (i + 1);
        theTag.addEventListener('click', function () { selectTimelineFrameLabel(this.id) });
        header.appendChild(theTag);

    }


    for (let i = 0; i < timelineViewport.cellsHigh; i++) {
        let theTag = document.createElement('div');
        theTag.classList = 'timeline-rowlabel';
        theTag.id = 'tl-rlab-' + i;
        theTag.innerHTML = "Pix" + (i + 1);
        theTag.addEventListener('click', function () { selectTimelineRowLabel(this.id) });
        sidebar.appendChild(theTag);
    }

    let gridContainer = document.createElement('div');
    gridContainer.id = "timeline-gridcont"


    for (let i = 0; i < timelineViewport.cellsWide; i++) {
        let gridLine = document.createElement('div');

        gridLine.classList = 'timeline-grid-col';
        if (i >= SelSeq.frames) gridLine.classList.add('hide');
        gridContainer.appendChild(gridLine);
    }
    workContainer.appendChild(gridContainer);

    //-----------------------------------------------------------------------------------------

    let sideScroller = document.createElement('input');
    sideScroller.type = "range";
    sideScroller.value = "0";
    sideScroller.min = "0";
    sideScroller.max = SelSeq.numPixels - timelineViewport.cellsHigh;//"241"; //number of pixels minus number of rows in viewport
    sideScroller.id = 'timeline-side-scroll';
    sideScroller.classList = "ux-scrollbarsliders ";
    workspace.appendChild(sideScroller);

    //----------------------------------------------------------------


    const indicatorTransitionRemove = () => {
        utilityAwaitDOMUpdate(function () {
            for (let i = 0; i < timelineViewport.cellsTall; i++) {
                let indicator = document.getElementById("timeline-indicator" + i);
                indicator.classList.remove("indicator-trandisable");
            }
        });
    }
    const indicatorTransitionAdd = () => {
        utilityAwaitDOMUpdate(function () {
            for (let i = 0; i < timelineViewport.cellsTall; i++) {
                let indicator = document.getElementById("timeline-indicator" + i);
                indicator.classList.add("indicator-trandisable");
            }
        });
    }

    sideScroller.addEventListener('input', function () {
        // console.log("Draginging side", this.value)
        timelineViewport.offsetY = Number(this.value);
        // fillCells();

        // indicatorTransitionRemove();
        // utilityAwaitDOMUpdate(function() {
        layoutTimelineUpdate();
        // indicatorTransitionAdd();
        // });
    });


    bottomScroller.addEventListener('input', function () {
        // console.log("Draginging bottom", this.value)
        timelineViewport.offsetX = Number(this.value);
        // fillCells();

        // indicatorTransitionRemove();
        // utilityAwaitDOMUpdate(function() {
        layoutTimelineUpdate();
        // indicatorTransitionAdd();
        // });
    })

    //================= draw ====================


    for (let i = 0; i < timelineViewport.cellsHigh; i++) {
        let row = document.createElement('div');
        row.classList = "timeline-row";
        row.id = 'tl-row-' + i;

        for (let q = 0; q < timelineViewport.cellsWide; q++) {
            let theCell = document.createElement('div');
            theCell.classList = 'tl-rc';
            theCell.id = 'tl-r' + i + '-c' + q;
            theCell.addEventListener('click', function () { selectTimelineCell(this.id) }); //attach color picking
            row.appendChild(theCell); //write to the DIV tag, will close </DIV> with whatever has been put into it
        } //end q for()


        //--------------------- Add startVal indicator for row --------------------------------------

        if (cDataSeqModesDataFrames.includes(SelSeq.mode)) {
            //Not check startvalues......only mFade/mGradient/mInstant/mTech
            var indicator = document.createElement('div'); //elevate scope to function, so it can be read outside of if()
            indicator.classList = 'tl-row-indicator indicator-trandisable'; //disables transition so they start in static position
            indicator.id = 'timeline-indicator' + i;
            indicator.addEventListener('mousedown', function () { selectTimelineIndicator(this) });
            row.appendChild(indicator);

            let shape = document.createElement('div');
            shape.classList = 'tl-row-indicator-shape';
            indicator.appendChild(shape);

            // indicator.setAttribute('onmouseout', 'if(stateUX.mouseTimer == null) uxToolTipHide()');
            // indicator.setAttribute('onmouseover', 'if(stateUX.mouseTimer == null) uxToolTipShow(this)'); 
            window.indicatorMouseout = function () { if (stateUX.mouseTimer == null) uxToolTipHide() };
            indicator.addEventListener('mouseout', window.indicatorMouseout);
            indicator.addEventListener('mouseover', function () { if (stateUX.mouseTimer == null) uxToolTipShow(this) });
        }

        workContainer.appendChild(row); //write to the DIV tag, will close </DIV> with whatever has been put into it
    }


    /*
            const fillCells = () => {
                let nextFrame = 0;
                let elemX = 0;
                let elemY = 0;
    
                let pixelOffset = Number(timelineViewport.offsetY) + timelineViewport.cellsHigh;
                if (pixelOffset > SelSeq.numPixels) {
                    console.log("over pixel limit")
                    pixelOffset = SelSeq.numPixels;
                }
    
                let frameOffset = timelineViewport.offsetX + timelineViewport.cellsWide;
                if (frameOffset > SelSeq.frames) {
                    console.log("over frames limit")
                    frameOffset = SelSeq.frames;
                }
    
                for (let i = timelineViewport.offsetY; i < pixelOffset; i++) { // SelSeq.numPixels
    
                    for (let q = timelineViewport.offsetX; q < frameOffset; q++) { // SelSeq.frame
                        let elem = document.getElementById('tl-r' + elemY + '-c' + elemX);
    
                        if ((q + 1) == SelSeq.frames) nextFrame = 0; //wrap to first frame
                        else nextFrame = (q + 1); //target next frame
    
                        //console.log( i, q)
                        switch (SelSeq.mode) {
                            case 'mFade':
                                getFrameGradient(elem, i, q, nextFrame);
                                break;
                            case 'mGradient':
                                getFrameGradient(elem, 0, q, nextFrame); //pix is always 0, since all use the same values
                                break;
                            case 'mFile':
                            case 'mScene':
                            case 'mInstant':
                                getFrameSolid(elem, i, q);
                                break;
                            default:
                            case 'mPOV':
                            case 'mList':
                            case 'mTechnical':
                                console.log("A major error occured, this should not happen");
                                break;
                        } //end switch
    
                        elemX++;
                    }
                    elemX = 0;
                    elemY++;
                }
    
                for (let i = 0; i < timelineViewport.cellsHigh; i++) {
                    document.getElementById('tl-rlab-' + i).innerHTML = "Pix" + (Number(i) + Number(timelineViewport.offsetY) + 1);
                    // console.log(i + timelineViewport.offsetY + 1, SelSeq.numPixels)
                    if ((i + timelineViewport.offsetY + 1) > SelSeq.numPixels) {
                        console.log("OVER, cellsHigh");
                    }
                }
    
                for (let i = 0; i < timelineViewport.cellsWide; i++) {
                    if (i >= SelSeq.frames) break;
                    // document.getElementById('tl-fbtn-' + i).innerHTML = "F" + (Number(i) + Number(timelineViewport.offsetX) + 1);
                    document.getElementById('tl-fbtn-' + i).innerHTML = (Number(i) + Number(timelineViewport.offsetX) + 1);
                    // document.getElementById('tl-fbtn-' + i).style.fontSize = "12px";
    
                    if ((i + timelineViewport.offsetX + 1) > SelSeq.frames) {
                        console.log("OVER, cellsWide");
                    }
                }
            }
    */
    if (cDataSeqModesDataFrames.includes(SelSeq.mode)) {
        utilityAwaitDOMUpdate(function () {
            const coords = document.getElementById("timeline-indicator0").parentElement.getBoundingClientRect();
            stateUX.indicatorStep = (coords.width / timelineViewport.cellsWide);
            stateUX.indicatorMax = stateUX.indicatorStep * SelSeq.frames; //messy, but works, once the indicator is dragged to the end, it expands the scrollWidth.
            // for (let i = 0; i < SelSeq.numPixels; i++) {
            //     let indicator = document.getElementById("timeline-indicator" + i);
            //     indicator.classList.remove("indicator-trandisable");
            // }

        });
    }

    // utilityAwaitDOMUpdate(fillCells); //wait until DOM has created the elements
    utilityAwaitDOMUpdate(layoutTimelineUpdate); //wait until DOM has created the elements
    // fillCells();

}

//========================================================================================================================================

function layoutPOVRender() {
    console.log("layoutPOVRender() " + SelSeq.filePath);

    document.getElementById("ws-timeline-container").innerHTML = ''; //destroy all the content
    document.getElementById("ws-timeline-container").style.removeProperty('display');//layoutTimelineRender() adds flex for regular timeline 

    //buttons for direction, spacing/gap(streaks or grid with spacing) method stuff, load file(or use import data?)
    //save file path to object and file

    //-------------------------------------------------------------

    let img = new Image();
    img.addEventListener('load', function () {
        let theTag = document.createElement('img');
        theTag.src = this.src;
        let theCont = document.getElementById("ws-pov-seqmodecont-prevcont");
        theCont.innerHTML = ''; //this is strange it doesn't clear(above) it under some conditions
        theCont.appendChild(theTag) //write to the DIV tag, will close </DIV> with whatever has been put into it
    });
    // img.addEventListener('error', function () {

    // });
    if (fs.existsSync(SelSeq.filePath)) img.src = SelSeq.filePath; //file exists, load it.
    else {
        //file does not exist. Run onerror event
        console.log("ERROR LOADING POV FILE");
        //fallback to load from dataFrames
        let theTag = document.createElement('div');
        theTag.innerText = `Image file not found, you must locate and reload it to make changes. The color data is still stored, and
         the sequence can be uploaded, but no preview or Direction Mode is available. <br>This will be fixed in a future asoftware version.`;
        theTag.className = "textCenter";
        let theCont = document.getElementById("ws-pov-seqmodecont-prevcont");
        theCont.innerHTML = ''; //this is strange it doesn't clear(above) it under some conditions
        theCont.appendChild(theTag) //write to the DIV tag, will close </DIV> with whatever has been put into it
    }
}

//========================================================================================================================================

function layoutFileRender() {
    console.log("layoutFileRender()");
    layoutTimelineRender(); //??
}

//========================================================================================================================================

function layoutListRender() {
    console.log("layoutListRender()");
    //ws-graphic-container
    //ws-timeline-container

    //-------------------------------------------------------------
    document.getElementById("ws-timeline-container").style.removeProperty('display');//layoutTimelineRender() adds flex for regular timeline 
    document.getElementById("ws-timeline-container").style.removeProperty('overflow');//layoutTimelineRender() adds flex for regular timeline 

    let mainCont = document.getElementById("ws-timeline-container");
    let contSect;
    let theTag; //scratch
    let theChild;

    mainCont.innerHTML = "";

    //-------------------------------------------------------------

    theTag = document.createElement('div');
    theTag.id = "ws-list-top"
    mainCont.appendChild(theTag); //write to the DIV tag, will close </DIV> with whatever has been put into it

    contSect = theTag; //target top section

    theTag = document.createElement('h1');
    theTag.innerText = "Sequence List:"
    theTag.id = "ws-list-title"
    contSect.appendChild(theTag); //write to the DIV tag, will close </DIV> with whatever has been put into it

    theTag = document.createElement('p');
    theTag.innerText = "Plays a list of sequences in series with options. Use the Add and Remove buttons to set the amount of Sequences on the List."
    theTag.id = "ws-list-description-text"
    contSect.appendChild(theTag); //write to the DIV tag, will close </DIV> with whatever has been put into it

    //-------------------------------------------------------------

    theTag = document.createElement('div');
    theTag.id = "ws-list-bottom"
    mainCont.appendChild(theTag); //write to the DIV tag, will close </DIV> with whatever has been put into it

    contSect = theTag; //target bottom section

    //-------------------------------------------------------------

    for (let i = 0; i < SelSeq.frames; i++) {
        let theEntry = document.createElement('div');

        theEntry.id = "ws-listentry-" + i;
        theEntry.className = "ws-listentry-style";
        contSect.appendChild(theEntry); //write to the DIV tag, will close </DIV> with whatever has been put into it

        //---------ID Number -------
        theChild = document.createElement('div');
        theChild.className = "ws-listentry-number";
        theChild.innerText = i + 1;
        theEntry.appendChild(theChild);

        //--------- Sequnce Tile -------
        theChild = document.createElement('div');
        theChild.className = "ws-listentry-seqtile";
        theEntry.appendChild(theChild);

        let theTile = document.createElement('div');
        theTile.className = "ws-listentry-seqtile-child";
        theChild.appendChild(theTile);

        uxToolTipAttach(theChild, 'Click to open menu and select a sequence to place into slot'); //TODO LOCALIZATION
        theChild.addEventListener('click', function (e) { overlayMenuEvent(e, 'open', 'menu-5', 'list'); stateUX.slotTarget = i; });

        //-------- Stepper and flag select --------

        theChild = document.createElement('div');
        theChild.className = "ws-listentry-time";
        theEntry.appendChild(theChild);

        let theHeader = document.createElement('h1');
        theHeader.innerText = "Iterations/Seconds:"; //TODO LOCALIZATION
        theChild.appendChild(theHeader);

        let theStepper = document.createElement('div');
        theStepper.id = 'ws-list-iteration-' + i;
        theStepper.className = "ws-listentry-steppers ux-numberstepper tooltip"
        theStepper.innerHTML = "<button class='uxNumStepper-down ux-buttons''>-</button><input id='ws-list-iterationval-" + i + "' class='uxNumStepper-value no-spinners' type='number' name='' value='1' min='1' max='65535'><button class='uxNumStepper-up ux-buttons'>+</button>";

        uxToolTipAttach(theStepper, 'Enter a value'); //TODO LOCALIZATION

        theChild.appendChild(theStepper);

        theStepper = document.createElement('div');
        theStepper.innerHTML = "<br>Iterations <label class='ux-switch switch-none-style'><input id='ws-list-time-select-" + i + "' type='checkbox' checked></input><span class='switch-slider arrowdirswitch'></span></label> Seconds";
        theChild.appendChild(theStepper);

        uxToolTipAttach(document.getElementById("ws-list-time-select-" + i).parentElement.parentElement, 'Select between timing in seconds or interations(count of number of times played)'); //TODO LOCALIZATION

        //attach the stepper functions, sinc those are done at program start, but these did not exist yet - do it after render

        //attach function for selector/checkbox - done here because of reasons
        document.getElementById("ws-list-time-select-" + i).addEventListener('change', function () {
            SelSeq.listFlags[i] &= 127; //clear toggle bit
            if (this.checked == true) SelSeq.listFlags[i] |= 128; //set toggle bit
            console.log("Linked Flags: " + i, SelSeq.listFlags[i], this.checked)
        });

        //----------Transition ------
        theChild = document.createElement('div');
        theChild.className = "ws-listentry-transition";
        theEntry.appendChild(theChild);

        theHeader = document.createElement('h1');
        theHeader.innerText = "Transition:";
        theChild.appendChild(theHeader);

        let theSelect = document.createElement('select');
        theSelect.id = "ws-list-transval-" + i;
        theSelect.className = "ux-dropdowns";

        theSelect.addEventListener('change', function () {
            SelSeq.listFlags[i] &= 128; //preserve interation/timer bit, clear all others
            if (this.selectedIndex == 3) SelSeq.listFlags[i] |= 7;
            else SelSeq.listFlags[i] |= this.selectedIndex;
            console.log("Linked Flags: " + i, SelSeq.listFlags[i], this.selectedIndex)
        });

        theChild.appendChild(theSelect);

        let theOpt = document.createElement('option');
        theOpt.textContent = "Instant";
        theOpt.value = 0;
        theSelect.appendChild(theOpt);

        theOpt = document.createElement('option');
        theOpt.textContent = "Fast Fade";
        theOpt.value = 1;
        theSelect.appendChild(theOpt);

        theOpt = document.createElement('option');
        theOpt.textContent = "Slow Fade";
        theOpt.value = 2;
        theSelect.appendChild(theOpt);

        theOpt = document.createElement('option');
        theOpt.textContent = "Per Sequence";
        theOpt.value = 7;
        theSelect.appendChild(theOpt);

        uxToolTipAttach(theSelect, 'Select a transition IN type.'); //TODO LOCALIZATION

        //------- Now set the element values/states from sequence data ---------

        if (SelSeq.listID[i] == null) {
            //indicates bad data or more likley the sequence was deleted
            //pushMessageToLog("The sequence assigned to slot#" + (i + 1) + " has been deleted, please select a different one.");
            let theTag = document.createElement('div');
            theTag.innerHTML = '<br>Error: Sequence Deleted, please re-select<br><br>Click to Select a Sequence'; //LOCALIZATION
            theTag.style.textAlign = 'center';
            theTile.appendChild(theTag) //write to the DIV tag, will close </DIV> with whatever has been put into it
        }
        else renderCommonSequenceTile(theTile, SelSeq.listID[i]); //or let it make a thumbnail normally

        document.getElementById("ws-list-iterationval-" + i).value = SelSeq.listIteration[i];
        //128 is the toggle flag
        if (SelSeq.listFlags[i] & 128) document.getElementById("ws-list-time-select-" + i).checked = true;
        else document.getElementById("ws-list-time-select-" + i).checked = false;

        //This is way to static, but quick
        let slotDD = document.getElementById("ws-list-transval-" + i);

        switch (SelSeq.listFlags[i] & 127) { //mask off MSB which is the iteration/timer bit
            case 0: //Instant
            case 1://Fase Fade
            case 2: //Slow Fade
                slotDD.selectedIndex = (SelSeq.listFlags[i] & 127); //same ID as the value
                break;
            case 7: //Per Sequence
                slotDD.selectedIndex = 3;
                break;
        }
    } //end for()

    //-------------------------------------------------------------

    //uses index which is the order of the NumSteppers in mainCont, if more steppers are added, this will get messed up - but works and was easy
    let statefulElements = mainCont.querySelectorAll('.uxNumStepper-up');
    statefulElements.forEach(function (el, index) {
        el.addEventListener('mousedown', function () { SelSeq.listIteration[index] = uxElemNumberStepper(this, "up"); });
    });

    statefulElements = mainCont.querySelectorAll('.uxNumStepper-down');
    statefulElements.forEach(function (el, index) {
        el.addEventListener('mousedown', function () { SelSeq.listIteration[index] = uxElemNumberStepper(this, "down") });
    });

    statefulElements = mainCont.querySelectorAll('.uxNumStepper-value');
    statefulElements.forEach(function (el, index) {
        el.addEventListener('input', function () { SelSeq.listIteration[index] = uxElemNumberStepper(this, "fix") });
    });

    //-------------------------------------------------------------

    //document.getElementById("ws-graphic-container").innerHTML = "";
    //document.getElementById("ws-graphic-container").appendChild(document.getElementById("ws-timeline-container"));    
}

//========================================================================================================================================

function sequenceResetStartValPositions(seq) {
    console.log("sequenceResetStartValPositions() " + seq.numPixels);
    stateSeq.startValPos = new Array(seq.numPixels).fill(0);
    stateSeq.startValPos.forEach(function (val, index) {
        sequenceLoadStartValPositions(seq, index);
    });
}

//========================================================================================================================================

//Loads the float position into the stateSeq.startValPos[] array based on seq.startVals[] and seq.frameVar[]
function sequenceLoadStartValPositions(seq, row) {
    // console.log("sequenceLoadStartValPositions() with " + row);

    //let indicator = document.getElementById('timeline-indicator' + row);
    let pixMult = getColorModeMult(seq.colorMode);
    let frameFloat = 1 / seq.frames; //creates the float each frame takes up - same for all colors

    if (seq.mode == 'mFade' || seq.mode == 'mGradient') {
        //per pixel. Get frame start and frame end, calculate percentage
        let frameVar;
        let nextFrame;
        let pixDataOffset;
        let pixFrameOffset = row * pixMult;
        if (seq.mode == 'mFade') pixDataOffset = row * pixMult;
        else if (seq.mode == 'mGradient') pixDataOffset = 0;

        frameVar = seq.frameVar[pixFrameOffset];
        if (frameVar == (seq.frames - 1)) nextFrame = 0; //wrap to first frame
        else nextFrame = (frameVar + 1); //target next frame
        // console.log("Pix#" + row + "    pixDataOffset: ", pixDataOffset, "   Frames: ", frameVar + " to ", nextFrame);

        //Start Values
        let startValR = seq.startVals[pixFrameOffset];
        let startValG = seq.startVals[pixFrameOffset + 1];
        let startValB = seq.startVals[pixFrameOffset + 2];
        let startValW = seq.startVals[pixFrameOffset + 3];

        //Current Frame - set in dataframevar[pixelcolor]
        let startR = seq.dataFrames[frameVar][pixDataOffset];
        let startG = seq.dataFrames[frameVar][pixDataOffset + 1];
        let startB = seq.dataFrames[frameVar][pixDataOffset + 2];
        let startW = seq.dataFrames[frameVar][pixDataOffset + 3];

        let endR = seq.dataFrames[nextFrame][pixDataOffset];
        let endG = seq.dataFrames[nextFrame][pixDataOffset + 1];
        let endB = seq.dataFrames[nextFrame][pixDataOffset + 2];
        let endW = seq.dataFrames[nextFrame][pixDataOffset + 3];

        //Check if StartValues are within range - handle RGBW? appears to be so, double check

        let errorMsg = "";

        if (!checkWithinRange(startR, endR, startValR)) {
            if (pixMult == 3 && (startValR == startValG && startValG == startValB)) {
                //console.log("Red startval was out of bounds, because it is a RGB preload");
            }
            else if (pixMult == 4 && (startValR == startValG && startValG == startValB && startValB == startValW)) {
                //console.log("Red startval was out of bounds, because it is a RGBW preload");
            }
            else {
                //console.log("Red startval was out of bounds, value reset to default");
                errorMsg += " Reset red start value for pix#" + (row + 1);
                seq.startVals[pixFrameOffset] = startR; //Handle Error by setting to default
                startValR = startR;
            }
        }

        if (pixMult > 1 && !checkWithinRange(startG, endG, startValG)) {
            if (pixMult == 3 && (startValR == startValG && startValG == startValB)) {
                //console.log("Green startval was out of bounds, because it is a RGB preload");
            }
            else if (pixMult == 4 && (startValR == startValG && startValG == startValB && startValB == startValW)) {
                //console.log("Green startval was out of bounds, because it is a RGBW preload");
            }
            else {
                //console.log("Green startval was out of bounds, value reset to default");
                errorMsg += " Reset green start value for pix#" + (row + 1);
                seq.startVals[pixFrameOffset + 1] = startG; //Handle Error by setting to default
                startValG = startG;
            }
        }

        if (pixMult > 1 && !checkWithinRange(startB, endB, startValB)) {
            if (pixMult == 3 && (startValR == startValG && startValG == startValB)) {
                //console.log("Blue startval was out of bounds, because it is a RGB preload");
            }
            else if (pixMult == 4 && (startValR == startValG && startValG == startValB && startValB == startValW)) {
                //console.log("Blue startval was out of bounds, because it is a RGBW preload");
            }
            else {
                //console.log("Blue startval was out of bounds, value reset to default");
                errorMsg += " Reset blue start value for pix#" + (row + 1);
                seq.startVals[pixFrameOffset + 2] = startB; //Handle Error by setting to default
                startValB = startB;
            }
        }

        if (pixMult == 4 && !checkWithinRange(startW, endW, startValW)) {
            if ((startValR == startValG && startValG == startValB && startValB == startValW)) {
                //console.log("White startval was out of bounds, because it is a RGBW preload");
            }
            else {
                //console.log("White startval was out of bounds, value reset to default");
                errorMsg += " Reset white start value for pix#" + (row + 1);
                seq.startVals[pixFrameOffset + 3] = startW; //Handle Error by setting to default
                startValW = startW;
            }
        }

        if (errorMsg != "") pushMessageToLog(errorMsg)

        //will this work the other way round? does the neg to positive make it work?
        let diffR = startR - endR;
        let diffG = startG - endG;
        let diffB = startB - endB;
        let diffW = startW - endW;

        if (diffR < 0) diffR *= -1; //it was negative, make it positive
        if (diffG < 0) diffG *= -1; //it was negative, make it positive
        if (diffB < 0) diffB *= -1; //it was negative, make it positive
        if (diffW < 0) diffW *= -1; //it was negative, make it positive

        let calcR = ((startR - startValR) / diffR); //result is the position within it's cell/frame as float
        let calcG = ((startG - startValG) / diffG);
        let calcB = ((startB - startValB) / diffB);
        let calcW = ((startW - startValW) / diffW);

        if (calcR < 0) calcR *= -1;
        if (calcG < 0) calcG *= -1;
        if (calcB < 0) calcB *= -1;
        if (calcW < 0) calcW *= -1;

        //if difference is 0, the start and end color are the same, the startvalue  is an indicator preload value
        let sameR = false;
        let sameG = false;
        let sameB = false;
        let sameW = false;

        if (startR == endR) sameR = true;
        if (startG == endG) sameG = true;
        if (startB == endB) sameB = true;
        if (startW == endW) sameW = true;

        //console.log("Calc, Pix#" + row + ": ", calcR, calcG, calcB, calcW);
        //console.log("Start Color, Pix#" + row + ": ", startR, startG, startB, startW);
        //console.log("End Color, Pix#" + row + ": ", endR, endG, endB, endW);
        //console.log("Color Difference, Pix#" + row + ": ", diffR, diffG, diffB, diffW);
        //console.log("Same, Pix#" + row + ": ", sameR, sameG, sameB, sameW);
        //console.log("StartVal, Pix#" + row + ": ", startValR, startValG, startValB, startValW);

        //------------------------------------

        let finalR;
        let finalG;
        let finalB;
        let finalW;
        finalR = finalG = finalB = finalW = (frameFloat * seq.frameVar[pixFrameOffset]); //frame/cell offset

        //console.log("frameFloat: ", frameFloat, "CalcR: ", calcR, "finalR: ", finalR); //results in the 
        finalR += (calcR * frameFloat); //red
        finalG += (calcG * frameFloat); //green
        finalB += (calcB * frameFloat); //blue
        finalW += (calcW * frameFloat); //white

        //console.log("finalR: ", finalR);
        //console.log("finalG: ", finalG);
        //console.log("finalB: ", finalB);
        //console.log("finalW: ", finalW);

        let finalX;
        let preloadVal = 0;

        //console.log(finalR,finalG,finalB);

        if (!sameR) {
            finalX = finalR;
            //console.log("Using red for finalX");
        }
        else if (!sameG) {
            finalX = finalG;
            //console.log("Using green for finalX");
        }
        else if (!sameB) {
            finalX = finalB;
            //console.log("Using blue for finalX");
        }
        else if (pixMult == 4 && !sameW) {
            finalX = finalW;
            //console.log("Using blue for finalX");
        }
        else {
            //console.log("All color values are the same, apply preload OR error")
            //console.log(startValR, startValG,startValB)
            if (pixMult == 3 && (startValR == startValG && startValG == startValB)) {
                //console.log("All start values are the same - RGB preload confirmed");
                //console.log(frameFloat, seq.frameVar[pixFrameOffset], startValR);
                preloadVal = (frameFloat * seq.frameVar[pixFrameOffset]); //set frame/cell offset
                finalX = ((startValR / 255) * frameFloat) + preloadVal; //use red but could be any of them, since they are all confirmed the same
            }
            else if (pixMult == 4 && (startValR == startValG && startValG == startValB && startValB == startValW)) {
                //console.log("All start values are the same - RGBW preload confirmed");
                preloadVal = (frameFloat * seq.frameVar[pixFrameOffset]); //set frame/cell offset
                finalX = ((startValR / 255) * frameFloat);//use red but could be any of them, since they are all confirmed the same
            }
            else if (pixMult == 3 || pixMult == 4) {
                //caught here startValues are not all the same
                //console.log("All StartValues do not match - preload ERROR");
                //this where to catch the error? set the startvalues, clear them or what?

                //Temp solution for error - it found the frame is preload, but the values are not all the same
                //  odds are it is ported, and the color values are the same as the current dataFrame[dataFrameVar]
                //  so there is no extractable preload data, just set it to 0% of the indicated dataFrame

                //console.log("StartValues for pixel#" + (pixFrameOffset / pixMult) + " reset");
                seq.startVals[pixFrameOffset] = 0;
                seq.startVals[pixFrameOffset + 1] = 0;
                seq.startVals[pixFrameOffset + 2] = 0;
                finalX = 0;
            }
        }

        //-------------- Now Place into start value position array -------------------------------------------

        //console.log(i + "   " + indicator.parentElement.scrollWidth + "    buildVal: ", buildVal + "   finalX: " + finalX);
        stateSeq.startValPos[row] = finalX;
    } //end if() fade, gradient
    else if (seq.mode == 'mInstant') {
        //it is an instant mode
        let finalX = (frameFloat * seq.frameVar[row * pixMult]);
        //console.log(finalX);
        stateSeq.startValPos[row] = finalX;
    }
    else if (seq.mode == 'mFile') {

    }
    else if (seq.mode == 'mScene') {

    }
    else {
        //it is an a non-compatible mode
        console.log("A major error has occured");
    }

    if( stateSeq.startValPos[row] == undefined)   stateSeq.startValPos[row] = 0; //how does this happen? for sure mono then increase channels, then edit the new channels
}

//========================================================================================================================================

